/* DBusAccelerator.c generated by valac 0.56.14, the Vala compiler
 * generated from DBusAccelerator.vala, do not modify */

/**/
/*  Copyright (C) 2015 Nicolas Bruguier, Corentin Noël*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <meta/prefs.h>
#include <gio/gio.h>
#include "gala.h"
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	GALA_ACTION_MODE_NONE = 0,
	GALA_ACTION_MODE_NORMAL = 1 << 0,
	GALA_ACTION_MODE_OVERVIEW = 1 << 1,
	GALA_ACTION_MODE_LOCK_SCREEN = 1 << 2,
	GALA_ACTION_MODE_UNLOCK_SCREEN = 1 << 3,
	GALA_ACTION_MODE_LOGIN_SCREEN = 1 << 4,
	GALA_ACTION_MODE_SYSTEM_MODAL = 1 << 5,
	GALA_ACTION_MODE_LOOKING_GLASS = 1 << 6,
	GALA_ACTION_MODE_POPUP = 1 << 7
} GalaActionMode;

#define GALA_TYPE_ACTION_MODE (gala_action_mode_get_type ())

#define GALA_TYPE_ACCELERATOR (gala_accelerator_get_type ())
typedef struct _GalaAccelerator GalaAccelerator;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GalaGrabbedAccelerator GalaGrabbedAccelerator;

#define GALA_TYPE_DBUS_ACCELERATOR (gala_dbus_accelerator_get_type ())
#define GALA_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAccelerator))
#define GALA_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorClass))
#define GALA_IS_DBUS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DBUS_ACCELERATOR))
#define GALA_IS_DBUS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DBUS_ACCELERATOR))
#define GALA_DBUS_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAcceleratorClass))

typedef struct _GalaDBusAccelerator GalaDBusAccelerator;
typedef struct _GalaDBusAcceleratorClass GalaDBusAcceleratorClass;
typedef struct _GalaDBusAcceleratorPrivate GalaDBusAcceleratorPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _gala_dbus_accelerator_unref0(var) ((var == NULL) ? NULL : (var = (gala_dbus_accelerator_unref (var), NULL)))
#define _gala_grabbed_accelerator_free0(var) ((var == NULL) ? NULL : (var = (gala_grabbed_accelerator_free (var), NULL)))
typedef struct _GalaParamSpecDBusAccelerator GalaParamSpecDBusAccelerator;
enum  {
	GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL,
	GALA_DBUS_ACCELERATOR_NUM_SIGNALS
};
static guint gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_NUM_SIGNALS] = {0};

struct _GalaAccelerator {
	gchar* name;
	GalaActionMode flags;
	MetaKeyBindingFlags grab_flags;
};

struct _GalaGrabbedAccelerator {
	gchar* name;
	GalaActionMode flags;
	MetaKeyBindingFlags grab_flags;
	guint action;
};

struct _GalaDBusAccelerator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaDBusAcceleratorPrivate * priv;
};

struct _GalaDBusAcceleratorClass {
	GTypeClass parent_class;
	void (*finalize) (GalaDBusAccelerator *self);
};

struct _GalaDBusAcceleratorPrivate {
	GalaWindowManager* wm;
	GHashTable* grabbed_accelerators;
};

struct _GalaParamSpecDBusAccelerator {
	GParamSpec parent_instance;
};

static gint GalaDBusAccelerator_private_offset;
static gpointer gala_dbus_accelerator_parent_class = NULL;
static GalaDBusAccelerator* gala_dbus_accelerator_instance;
static GalaDBusAccelerator* gala_dbus_accelerator_instance = NULL;

VALA_EXTERN GType gala_action_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_accelerator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GalaAccelerator* gala_accelerator_dup (const GalaAccelerator* self);
VALA_EXTERN void gala_accelerator_free (GalaAccelerator* self);
VALA_EXTERN void gala_accelerator_copy (const GalaAccelerator* self,
                            GalaAccelerator* dest);
VALA_EXTERN void gala_accelerator_destroy (GalaAccelerator* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (GalaAccelerator, gala_accelerator_destroy)
 G_GNUC_INTERNAL void gala_grabbed_accelerator_free (GalaGrabbedAccelerator * self);
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGrabbedAccelerator, gala_grabbed_accelerator_free)
static void gala_grabbed_accelerator_instance_init (GalaGrabbedAccelerator * self);
 G_GNUC_INTERNAL GalaGrabbedAccelerator* gala_grabbed_accelerator_new (void);
VALA_EXTERN gpointer gala_dbus_accelerator_ref (gpointer instance);
VALA_EXTERN void gala_dbus_accelerator_unref (gpointer instance);
VALA_EXTERN GParamSpec* gala_param_spec_dbus_accelerator (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void gala_value_set_dbus_accelerator (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void gala_value_take_dbus_accelerator (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer gala_value_get_dbus_accelerator (const GValue* value);
VALA_EXTERN GType gala_dbus_accelerator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDBusAccelerator, gala_dbus_accelerator_unref)
VALA_EXTERN guint gala_dbus_accelerator_register_object (void* object,
                                             GDBusConnection* connection,
                                             const gchar* path,
                                             GError** error);
VALA_EXTERN GalaDBusAccelerator* gala_dbus_accelerator_init (GalaWindowManager* wm);
static GalaDBusAccelerator* gala_dbus_accelerator_new (GalaWindowManager* _wm);
static GalaDBusAccelerator* gala_dbus_accelerator_construct (GType object_type,
                                                      GalaWindowManager* _wm);
static void _gala_grabbed_accelerator_free0_ (gpointer var);
static void gala_dbus_accelerator_on_accelerator_activated (GalaDBusAccelerator* self,
                                                     guint action,
                                                     ClutterInputDevice* device,
                                                     guint timestamp);
static void _gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated (MetaDisplay* _sender,
                                                                                         guint object,
                                                                                         ClutterInputDevice* p0,
                                                                                         guint p1,
                                                                                         gpointer self);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
VALA_EXTERN guint gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                              const gchar* accelerator,
                                              GalaActionMode flags,
                                              MetaKeyBindingFlags grab_flags,
                                              GError** error);
VALA_EXTERN guint* gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                                GalaAccelerator* accelerators,
                                                gint accelerators_length1,
                                                gint* result_length1,
                                                GError** error);
static void _vala_array_add1 (guint* * array,
                       gint* length,
                       gint* size,
                       guint value);
VALA_EXTERN gboolean gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                   guint action,
                                                   GError** error);
VALA_EXTERN gboolean gala_dbus_accelerator_ungrab_accelerators (GalaDBusAccelerator* self,
                                                    guint* actions,
                                                    gint actions_length1,
                                                    GError** error);
VALA_EXTERN void gala_dbus_accelerator_show_osd (GalaDBusAccelerator* self,
                                     GHashTable* parameters,
                                     GError** error);
VALA_EXTERN void gala_media_feedback_send (const gchar* icon,
                               gint val);
static void g_cclosure_user_marshal_VOID__UINT_BOXED (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void gala_dbus_accelerator_finalize (GalaDBusAccelerator * obj);
static GType gala_dbus_accelerator_get_type_once (void);
static void _dbus_gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _vala_GalaAccelerator_array_free (GalaAccelerator * array,
                                       gssize array_length);
static void _dbus_gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_gala_dbus_accelerator_ungrab_accelerators (GalaDBusAccelerator* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_gala_dbus_accelerator_show_osd (GalaDBusAccelerator* self,
                                           GVariant* _parameters_,
                                           GDBusMethodInvocation* invocation);
static void gala_dbus_accelerator_dbus_interface_method_call (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* method_name,
                                                       GVariant* parameters,
                                                       GDBusMethodInvocation* invocation,
                                                       gpointer user_data);
static GVariant* gala_dbus_accelerator_dbus_interface_get_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GError** error,
                                                             gpointer user_data);
static gboolean gala_dbus_accelerator_dbus_interface_set_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GVariant* value,
                                                            GError** error,
                                                            gpointer user_data);
static void _dbus_gala_dbus_accelerator_accelerator_activated (GObject* _sender,
                                                        guint action,
                                                        GHashTable* parameters,
                                                        gpointer* _data);
static void _gala_dbus_accelerator_unregister_object (gpointer user_data);

static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_accelerator = {-1, "accelerator", "s", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_flags = {-1, "flags", "u", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_grab_flags = {-1, "grab_flags", "u", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_result = {-1, "result", "u", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_in[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_accelerator, &_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_flags, &_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_grab_flags, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerator_out[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_grab_accelerator = {-1, "GrabAccelerator", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerator_out), NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_accelerators = {-1, "accelerators", "a(suu)", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_result = {-1, "result", "au", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_in[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_accelerators, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_grab_accelerators_out[] = {&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_grab_accelerators = {-1, "GrabAccelerators", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_grab_accelerators_out), NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_action = {-1, "action", "u", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_in[] = {&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_action, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_out[] = {&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_ungrab_accelerator = {-1, "UngrabAccelerator", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerator_out), NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerators_actions = {-1, "actions", "au", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerators_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerators_in[] = {&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerators_actions, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_ungrab_accelerators_out[] = {&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerators_result, NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_ungrab_accelerators = {-1, "UngrabAccelerators", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerators_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_ungrab_accelerators_out), NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_show_osd_parameters = {-1, "parameters", "a{sv}", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_show_osd_in[] = {&_gala_dbus_accelerator_dbus_arg_info_show_osd_parameters, NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_show_osd_out[] = {NULL};
static const GDBusMethodInfo _gala_dbus_accelerator_dbus_method_info_show_osd = {-1, "ShowOSD", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_show_osd_in), (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_show_osd_out), NULL};
static const GDBusMethodInfo * const _gala_dbus_accelerator_dbus_method_info[] = {&_gala_dbus_accelerator_dbus_method_info_grab_accelerator, &_gala_dbus_accelerator_dbus_method_info_grab_accelerators, &_gala_dbus_accelerator_dbus_method_info_ungrab_accelerator, &_gala_dbus_accelerator_dbus_method_info_ungrab_accelerators, &_gala_dbus_accelerator_dbus_method_info_show_osd, NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_accelerator_activated_action = {-1, "action", "u", NULL};
static const GDBusArgInfo _gala_dbus_accelerator_dbus_arg_info_accelerator_activated_parameters = {-1, "parameters", "a{sv}", NULL};
static const GDBusArgInfo * const _gala_dbus_accelerator_dbus_arg_info_accelerator_activated[] = {&_gala_dbus_accelerator_dbus_arg_info_accelerator_activated_action, &_gala_dbus_accelerator_dbus_arg_info_accelerator_activated_parameters, NULL};
static const GDBusSignalInfo _gala_dbus_accelerator_dbus_signal_info_accelerator_activated = {-1, "AcceleratorActivated", (GDBusArgInfo **) (&_gala_dbus_accelerator_dbus_arg_info_accelerator_activated), NULL};
static const GDBusSignalInfo * const _gala_dbus_accelerator_dbus_signal_info[] = {&_gala_dbus_accelerator_dbus_signal_info_accelerator_activated, NULL};
static const GDBusPropertyInfo * const _gala_dbus_accelerator_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gala_dbus_accelerator_dbus_interface_info = {-1, "org.gnome.Shell", (GDBusMethodInfo **) (&_gala_dbus_accelerator_dbus_method_info), (GDBusSignalInfo **) (&_gala_dbus_accelerator_dbus_signal_info), (GDBusPropertyInfo **) (&_gala_dbus_accelerator_dbus_property_info), NULL};
static const GDBusInterfaceVTable _gala_dbus_accelerator_dbus_interface_vtable = {gala_dbus_accelerator_dbus_interface_method_call, gala_dbus_accelerator_dbus_interface_get_property, gala_dbus_accelerator_dbus_interface_set_property};

/**
     * ActionMode:
     * @NONE: block action
     * @NORMAL: allow action when in window mode, e.g. when the focus is in an application window
     * @OVERVIEW: allow action while the overview is active
     * @LOCK_SCREEN: allow action when the screen is locked, e.g. when the screen shield is shown
     * @UNLOCK_SCREEN: allow action in the unlock dialog
     * @LOGIN_SCREEN: allow action in the login screen
     * @SYSTEM_MODAL: allow action when a system modal dialog (e.g. authentification or session dialogs) is open
     * @LOOKING_GLASS: allow action in looking glass
     * @POPUP: allow action while a shell menu is open
     */
static GType
gala_action_mode_get_type_once (void)
{
	static const GFlagsValue values[] = {{GALA_ACTION_MODE_NONE, "GALA_ACTION_MODE_NONE", "none"}, {GALA_ACTION_MODE_NORMAL, "GALA_ACTION_MODE_NORMAL", "normal"}, {GALA_ACTION_MODE_OVERVIEW, "GALA_ACTION_MODE_OVERVIEW", "overview"}, {GALA_ACTION_MODE_LOCK_SCREEN, "GALA_ACTION_MODE_LOCK_SCREEN", "lock-screen"}, {GALA_ACTION_MODE_UNLOCK_SCREEN, "GALA_ACTION_MODE_UNLOCK_SCREEN", "unlock-screen"}, {GALA_ACTION_MODE_LOGIN_SCREEN, "GALA_ACTION_MODE_LOGIN_SCREEN", "login-screen"}, {GALA_ACTION_MODE_SYSTEM_MODAL, "GALA_ACTION_MODE_SYSTEM_MODAL", "system-modal"}, {GALA_ACTION_MODE_LOOKING_GLASS, "GALA_ACTION_MODE_LOOKING_GLASS", "looking-glass"}, {GALA_ACTION_MODE_POPUP, "GALA_ACTION_MODE_POPUP", "popup"}, {0, NULL, NULL}};
	GType gala_action_mode_type_id;
	gala_action_mode_type_id = g_flags_register_static ("GalaActionMode", values);
	return gala_action_mode_type_id;
}

GType
gala_action_mode_get_type (void)
{
	static volatile gsize gala_action_mode_type_id__once = 0;
	if (g_once_init_enter (&gala_action_mode_type_id__once)) {
		GType gala_action_mode_type_id;
		gala_action_mode_type_id = gala_action_mode_get_type_once ();
		g_once_init_leave (&gala_action_mode_type_id__once, gala_action_mode_type_id);
	}
	return gala_action_mode_type_id__once;
}

void
gala_accelerator_copy (const GalaAccelerator* self,
                       GalaAccelerator* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 44 "../src/DBusAccelerator.vala"
	_tmp0_ = (*self).name;
#line 44 "../src/DBusAccelerator.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 44 "../src/DBusAccelerator.vala"
	_g_free0 ((*dest).name);
#line 44 "../src/DBusAccelerator.vala"
	(*dest).name = _tmp1_;
#line 44 "../src/DBusAccelerator.vala"
	(*dest).flags = (*self).flags;
#line 44 "../src/DBusAccelerator.vala"
	(*dest).grab_flags = (*self).grab_flags;
#line 343 "DBusAccelerator.c"
}

void
gala_accelerator_destroy (GalaAccelerator* self)
{
#line 45 "../src/DBusAccelerator.vala"
	_g_free0 ((*self).name);
#line 351 "DBusAccelerator.c"
}

GalaAccelerator*
gala_accelerator_dup (const GalaAccelerator* self)
{
	GalaAccelerator* dup;
#line 44 "../src/DBusAccelerator.vala"
	dup = g_new0 (GalaAccelerator, 1);
#line 44 "../src/DBusAccelerator.vala"
	gala_accelerator_copy (self, dup);
#line 44 "../src/DBusAccelerator.vala"
	return dup;
#line 364 "DBusAccelerator.c"
}

void
gala_accelerator_free (GalaAccelerator* self)
{
#line 44 "../src/DBusAccelerator.vala"
	gala_accelerator_destroy (self);
#line 44 "../src/DBusAccelerator.vala"
	g_free (self);
#line 374 "DBusAccelerator.c"
}

static GType
gala_accelerator_get_type_once (void)
{
	GType gala_accelerator_type_id;
	gala_accelerator_type_id = g_boxed_type_register_static ("GalaAccelerator", (GBoxedCopyFunc) gala_accelerator_dup, (GBoxedFreeFunc) gala_accelerator_free);
	return gala_accelerator_type_id;
}

GType
gala_accelerator_get_type (void)
{
	static volatile gsize gala_accelerator_type_id__once = 0;
	if (g_once_init_enter (&gala_accelerator_type_id__once)) {
		GType gala_accelerator_type_id;
		gala_accelerator_type_id = gala_accelerator_get_type_once ();
		g_once_init_leave (&gala_accelerator_type_id__once, gala_accelerator_type_id);
	}
	return gala_accelerator_type_id__once;
}

 G_GNUC_INTERNAL GalaGrabbedAccelerator*
gala_grabbed_accelerator_new (void)
{
	GalaGrabbedAccelerator* self;
#line 51 "../src/DBusAccelerator.vala"
	self = g_slice_new0 (GalaGrabbedAccelerator);
#line 51 "../src/DBusAccelerator.vala"
	gala_grabbed_accelerator_instance_init (self);
#line 51 "../src/DBusAccelerator.vala"
	return self;
#line 407 "DBusAccelerator.c"
}

static void
gala_grabbed_accelerator_instance_init (GalaGrabbedAccelerator * self)
{
}

 G_GNUC_INTERNAL void
gala_grabbed_accelerator_free (GalaGrabbedAccelerator * self)
{
#line 52 "../src/DBusAccelerator.vala"
	_g_free0 (self->name);
#line 51 "../src/DBusAccelerator.vala"
	g_slice_free (GalaGrabbedAccelerator, self);
#line 422 "DBusAccelerator.c"
}

static inline gpointer
gala_dbus_accelerator_get_instance_private (GalaDBusAccelerator* self)
{
	return G_STRUCT_MEMBER_P (self, GalaDBusAccelerator_private_offset);
}

GalaDBusAccelerator*
gala_dbus_accelerator_init (GalaWindowManager* wm)
{
	GalaDBusAccelerator* _tmp0_;
	GalaDBusAccelerator* _tmp2_;
	GalaDBusAccelerator* result;
#line 63 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 64 "../src/DBusAccelerator.vala"
	_tmp0_ = gala_dbus_accelerator_instance;
#line 64 "../src/DBusAccelerator.vala"
	if (_tmp0_ == NULL) {
#line 443 "DBusAccelerator.c"
		GalaDBusAccelerator* _tmp1_;
#line 65 "../src/DBusAccelerator.vala"
		_tmp1_ = gala_dbus_accelerator_new (wm);
#line 65 "../src/DBusAccelerator.vala"
		_gala_dbus_accelerator_unref0 (gala_dbus_accelerator_instance);
#line 65 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_instance = _tmp1_;
#line 451 "DBusAccelerator.c"
	}
#line 67 "../src/DBusAccelerator.vala"
	_tmp2_ = gala_dbus_accelerator_instance;
#line 67 "../src/DBusAccelerator.vala"
	result = _tmp2_;
#line 67 "../src/DBusAccelerator.vala"
	return result;
#line 459 "DBusAccelerator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../src/DBusAccelerator.vala"
	return self ? g_object_ref (self) : NULL;
#line 467 "DBusAccelerator.c"
}

static void
_gala_grabbed_accelerator_free0_ (gpointer var)
{
#line 77 "../src/DBusAccelerator.vala"
	(var == NULL) ? NULL : (var = (gala_grabbed_accelerator_free (var), NULL));
#line 475 "DBusAccelerator.c"
}

static void
_gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated (MetaDisplay* _sender,
                                                                                    guint object,
                                                                                    ClutterInputDevice* p0,
                                                                                    guint p1,
                                                                                    gpointer self)
{
#line 78 "../src/DBusAccelerator.vala"
	gala_dbus_accelerator_on_accelerator_activated ((GalaDBusAccelerator*) self, object, p0, p1);
#line 487 "DBusAccelerator.c"
}

static GalaDBusAccelerator*
gala_dbus_accelerator_construct (GType object_type,
                                 GalaWindowManager* _wm)
{
	GalaDBusAccelerator* self = NULL;
	GalaWindowManager* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GalaWindowManager* _tmp4_;
	MetaDisplay* _tmp5_;
#line 75 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (_wm != NULL, NULL);
#line 75 "../src/DBusAccelerator.vala"
	self = (GalaDBusAccelerator*) g_type_create_instance (object_type);
#line 76 "../src/DBusAccelerator.vala"
	_tmp0_ = _g_object_ref0 (_wm);
#line 76 "../src/DBusAccelerator.vala"
	_g_object_unref0 (self->priv->wm);
#line 76 "../src/DBusAccelerator.vala"
	self->priv->wm = _tmp0_;
#line 77 "../src/DBusAccelerator.vala"
	_tmp1_ = g_str_hash;
#line 77 "../src/DBusAccelerator.vala"
	_tmp2_ = g_str_equal;
#line 77 "../src/DBusAccelerator.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, NULL, _gala_grabbed_accelerator_free0_);
#line 77 "../src/DBusAccelerator.vala"
	_g_hash_table_unref0 (self->priv->grabbed_accelerators);
#line 77 "../src/DBusAccelerator.vala"
	self->priv->grabbed_accelerators = _tmp3_;
#line 78 "../src/DBusAccelerator.vala"
	_tmp4_ = self->priv->wm;
#line 78 "../src/DBusAccelerator.vala"
	_tmp5_ = meta_plugin_get_display ((MetaPlugin*) _tmp4_);
#line 78 "../src/DBusAccelerator.vala"
	g_signal_connect (_tmp5_, "accelerator-activated", (GCallback) _gala_dbus_accelerator_on_accelerator_activated_meta_display_accelerator_activated, self);
#line 75 "../src/DBusAccelerator.vala"
	return self;
#line 529 "DBusAccelerator.c"
}

static GalaDBusAccelerator*
gala_dbus_accelerator_new (GalaWindowManager* _wm)
{
#line 75 "../src/DBusAccelerator.vala"
	return gala_dbus_accelerator_construct (GALA_TYPE_DBUS_ACCELERATOR, _wm);
#line 537 "DBusAccelerator.c"
}

static void
_g_free0_ (gpointer var)
{
#line 84 "../src/DBusAccelerator.vala"
	var = (g_free (var), NULL);
#line 545 "DBusAccelerator.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 84 "../src/DBusAccelerator.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 553 "DBusAccelerator.c"
}

static void
gala_dbus_accelerator_on_accelerator_activated (GalaDBusAccelerator* self,
                                                guint action,
                                                ClutterInputDevice* device,
                                                guint timestamp)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 81 "../src/DBusAccelerator.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/DBusAccelerator.vala"
	g_return_if_fail (device != NULL);
#line 82 "../src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 82 "../src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 572 "DBusAccelerator.c"
	{
		GList* accel_collection = NULL;
		GList* accel_it = NULL;
#line 82 "../src/DBusAccelerator.vala"
		accel_collection = _tmp1_;
#line 82 "../src/DBusAccelerator.vala"
		for (accel_it = accel_collection; accel_it != NULL; accel_it = accel_it->next) {
#line 580 "DBusAccelerator.c"
			GalaGrabbedAccelerator* accel = NULL;
#line 82 "../src/DBusAccelerator.vala"
			accel = (GalaGrabbedAccelerator*) accel_it->data;
#line 584 "DBusAccelerator.c"
			{
				GalaGrabbedAccelerator* _tmp2_;
#line 83 "../src/DBusAccelerator.vala"
				_tmp2_ = accel;
#line 83 "../src/DBusAccelerator.vala"
				if (_tmp2_->action == action) {
#line 591 "DBusAccelerator.c"
					GHashTable* parameters = NULL;
					GHashTable* _tmp3_;
					GHashTable* _tmp4_;
					gchar* _tmp5_;
					GVariant* _tmp6_;
					const gchar* _tmp7_;
					const gchar* _tmp8_;
					GHashTable* _tmp14_;
#line 84 "../src/DBusAccelerator.vala"
					_tmp3_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_variant_unref0_);
#line 84 "../src/DBusAccelerator.vala"
					parameters = _tmp3_;
#line 85 "../src/DBusAccelerator.vala"
					_tmp4_ = parameters;
#line 85 "../src/DBusAccelerator.vala"
					_tmp5_ = g_strdup ("timestamp");
#line 85 "../src/DBusAccelerator.vala"
					_tmp6_ = g_variant_new_uint32 ((guint32) timestamp);
#line 85 "../src/DBusAccelerator.vala"
					g_variant_ref_sink (_tmp6_);
#line 85 "../src/DBusAccelerator.vala"
					g_hash_table_insert (_tmp4_, _tmp5_, _tmp6_);
#line 86 "../src/DBusAccelerator.vala"
					_tmp7_ = clutter_input_device_get_device_node (device);
#line 86 "../src/DBusAccelerator.vala"
					_tmp8_ = _tmp7_;
#line 86 "../src/DBusAccelerator.vala"
					if (_tmp8_ != NULL) {
#line 620 "DBusAccelerator.c"
						GHashTable* _tmp9_;
						gchar* _tmp10_;
						const gchar* _tmp11_;
						const gchar* _tmp12_;
						GVariant* _tmp13_;
#line 87 "../src/DBusAccelerator.vala"
						_tmp9_ = parameters;
#line 87 "../src/DBusAccelerator.vala"
						_tmp10_ = g_strdup ("device-node");
#line 87 "../src/DBusAccelerator.vala"
						_tmp11_ = clutter_input_device_get_device_node (device);
#line 87 "../src/DBusAccelerator.vala"
						_tmp12_ = _tmp11_;
#line 87 "../src/DBusAccelerator.vala"
						_tmp13_ = g_variant_new_string (_tmp12_);
#line 87 "../src/DBusAccelerator.vala"
						g_variant_ref_sink (_tmp13_);
#line 87 "../src/DBusAccelerator.vala"
						g_hash_table_insert (_tmp9_, _tmp10_, _tmp13_);
#line 640 "DBusAccelerator.c"
					}
#line 90 "../src/DBusAccelerator.vala"
					_tmp14_ = parameters;
#line 90 "../src/DBusAccelerator.vala"
					g_signal_emit (self, gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL], 0, action, _tmp14_);
#line 92 "../src/DBusAccelerator.vala"
					_g_hash_table_unref0 (parameters);
#line 92 "../src/DBusAccelerator.vala"
					(accel_collection == NULL) ? NULL : (accel_collection = (g_list_free (accel_collection), NULL));
#line 92 "../src/DBusAccelerator.vala"
					return;
#line 652 "DBusAccelerator.c"
				}
			}
		}
#line 82 "../src/DBusAccelerator.vala"
		(accel_collection == NULL) ? NULL : (accel_collection = (g_list_free (accel_collection), NULL));
#line 658 "DBusAccelerator.c"
	}
}

guint
gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                        const gchar* accelerator,
                                        GalaActionMode flags,
                                        MetaKeyBindingFlags grab_flags,
                                        GError** error)
{
	GalaGrabbedAccelerator* found_accel = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GalaGrabbedAccelerator* _tmp2_;
	guint action = 0U;
	GalaWindowManager* _tmp4_;
	MetaDisplay* _tmp5_;
	guint result;
#line 97 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 97 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (accelerator != NULL, 0U);
#line 98 "../src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 98 "../src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, accelerator);
#line 98 "../src/DBusAccelerator.vala"
	found_accel = (GalaGrabbedAccelerator*) _tmp1_;
#line 99 "../src/DBusAccelerator.vala"
	_tmp2_ = found_accel;
#line 99 "../src/DBusAccelerator.vala"
	if (_tmp2_ != NULL) {
#line 691 "DBusAccelerator.c"
		GalaGrabbedAccelerator* _tmp3_;
#line 100 "../src/DBusAccelerator.vala"
		_tmp3_ = found_accel;
#line 100 "../src/DBusAccelerator.vala"
		result = _tmp3_->action;
#line 100 "../src/DBusAccelerator.vala"
		return result;
#line 699 "DBusAccelerator.c"
	}
#line 103 "../src/DBusAccelerator.vala"
	_tmp4_ = self->priv->wm;
#line 103 "../src/DBusAccelerator.vala"
	_tmp5_ = meta_plugin_get_display ((MetaPlugin*) _tmp4_);
#line 103 "../src/DBusAccelerator.vala"
	action = meta_display_grab_accelerator (_tmp5_, accelerator, grab_flags);
#line 104 "../src/DBusAccelerator.vala"
	if (action != ((guint) META_KEY_BINDING_NONE)) {
#line 709 "DBusAccelerator.c"
		GalaGrabbedAccelerator* accel = NULL;
		GalaGrabbedAccelerator* _tmp6_;
		GalaGrabbedAccelerator* _tmp7_;
		GalaGrabbedAccelerator* _tmp8_;
		gchar* _tmp9_;
		GalaGrabbedAccelerator* _tmp10_;
		GalaGrabbedAccelerator* _tmp11_;
		GHashTable* _tmp12_;
		GalaGrabbedAccelerator* _tmp13_;
		const gchar* _tmp14_;
		GalaGrabbedAccelerator* _tmp15_;
#line 105 "../src/DBusAccelerator.vala"
		_tmp6_ = gala_grabbed_accelerator_new ();
#line 105 "../src/DBusAccelerator.vala"
		accel = _tmp6_;
#line 106 "../src/DBusAccelerator.vala"
		_tmp7_ = accel;
#line 106 "../src/DBusAccelerator.vala"
		_tmp7_->action = action;
#line 107 "../src/DBusAccelerator.vala"
		_tmp8_ = accel;
#line 107 "../src/DBusAccelerator.vala"
		_tmp9_ = g_strdup (accelerator);
#line 107 "../src/DBusAccelerator.vala"
		_g_free0 (_tmp8_->name);
#line 107 "../src/DBusAccelerator.vala"
		_tmp8_->name = _tmp9_;
#line 108 "../src/DBusAccelerator.vala"
		_tmp10_ = accel;
#line 108 "../src/DBusAccelerator.vala"
		_tmp10_->flags = flags;
#line 109 "../src/DBusAccelerator.vala"
		_tmp11_ = accel;
#line 109 "../src/DBusAccelerator.vala"
		_tmp11_->grab_flags = grab_flags;
#line 110 "../src/DBusAccelerator.vala"
		_tmp12_ = self->priv->grabbed_accelerators;
#line 110 "../src/DBusAccelerator.vala"
		_tmp13_ = accel;
#line 110 "../src/DBusAccelerator.vala"
		_tmp14_ = _tmp13_->name;
#line 110 "../src/DBusAccelerator.vala"
		_tmp15_ = accel;
#line 110 "../src/DBusAccelerator.vala"
		accel = NULL;
#line 110 "../src/DBusAccelerator.vala"
		g_hash_table_insert (_tmp12_, _tmp14_, _tmp15_);
#line 104 "../src/DBusAccelerator.vala"
		_gala_grabbed_accelerator_free0 (accel);
#line 759 "DBusAccelerator.c"
	}
#line 113 "../src/DBusAccelerator.vala"
	result = action;
#line 113 "../src/DBusAccelerator.vala"
	return result;
#line 765 "DBusAccelerator.c"
}

static void
_vala_array_add1 (guint* * array,
                  gint* length,
                  gint* size,
                  guint value)
{
#line 120 "../src/DBusAccelerator.vala"
	if ((*length) == (*size)) {
#line 120 "../src/DBusAccelerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 120 "../src/DBusAccelerator.vala"
		*array = g_renew (guint, *array, *size);
#line 780 "DBusAccelerator.c"
	}
#line 120 "../src/DBusAccelerator.vala"
	(*array)[(*length)++] = value;
#line 784 "DBusAccelerator.c"
}

guint*
gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                         GalaAccelerator* accelerators,
                                         gint accelerators_length1,
                                         gint* result_length1,
                                         GError** error)
{
	guint* actions = NULL;
	guint* _tmp0_;
	gint actions_length1;
	gint _actions_size_;
	guint* _tmp6_;
	gint _tmp6__length1;
	GError* _inner_error0_ = NULL;
	guint* result;
#line 116 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../src/DBusAccelerator.vala"
	_tmp0_ = g_new0 (guint, 0);
#line 117 "../src/DBusAccelerator.vala"
	actions = _tmp0_;
#line 117 "../src/DBusAccelerator.vala"
	actions_length1 = 0;
#line 117 "../src/DBusAccelerator.vala"
	_actions_size_ = actions_length1;
#line 812 "DBusAccelerator.c"
	{
		GalaAccelerator* accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 119 "../src/DBusAccelerator.vala"
		accelerator_collection = accelerators;
#line 119 "../src/DBusAccelerator.vala"
		accelerator_collection_length1 = accelerators_length1;
#line 119 "../src/DBusAccelerator.vala"
		for (accelerator_it = 0; accelerator_it < accelerator_collection_length1; accelerator_it = accelerator_it + 1) {
#line 824 "DBusAccelerator.c"
			GalaAccelerator accelerator = {0};
#line 119 "../src/DBusAccelerator.vala"
			accelerator = accelerator_collection[accelerator_it];
#line 828 "DBusAccelerator.c"
			{
				guint _tmp1_ = 0U;
				GalaAccelerator _tmp2_;
				const gchar* _tmp3_;
				GalaAccelerator _tmp4_;
				GalaAccelerator _tmp5_;
#line 120 "../src/DBusAccelerator.vala"
				_tmp2_ = accelerator;
#line 120 "../src/DBusAccelerator.vala"
				_tmp3_ = _tmp2_.name;
#line 120 "../src/DBusAccelerator.vala"
				_tmp4_ = accelerator;
#line 120 "../src/DBusAccelerator.vala"
				_tmp5_ = accelerator;
#line 120 "../src/DBusAccelerator.vala"
				_tmp1_ = gala_dbus_accelerator_grab_accelerator (self, _tmp3_, _tmp4_.flags, _tmp5_.grab_flags, &_inner_error0_);
#line 120 "../src/DBusAccelerator.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../src/DBusAccelerator.vala"
					if ((_inner_error0_->domain == G_DBUS_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 120 "../src/DBusAccelerator.vala"
						g_propagate_error (error, _inner_error0_);
#line 120 "../src/DBusAccelerator.vala"
						actions = (g_free (actions), NULL);
#line 120 "../src/DBusAccelerator.vala"
						return NULL;
#line 855 "DBusAccelerator.c"
					} else {
#line 120 "../src/DBusAccelerator.vala"
						actions = (g_free (actions), NULL);
#line 120 "../src/DBusAccelerator.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/DBusAccelerator.vala"
						g_clear_error (&_inner_error0_);
#line 120 "../src/DBusAccelerator.vala"
						return NULL;
#line 865 "DBusAccelerator.c"
					}
				}
#line 120 "../src/DBusAccelerator.vala"
				_vala_array_add1 (&actions, &actions_length1, &_actions_size_, _tmp1_);
#line 870 "DBusAccelerator.c"
			}
		}
	}
#line 123 "../src/DBusAccelerator.vala"
	_tmp6_ = actions;
#line 123 "../src/DBusAccelerator.vala"
	_tmp6__length1 = actions_length1;
#line 123 "../src/DBusAccelerator.vala"
	if (result_length1) {
#line 123 "../src/DBusAccelerator.vala"
		*result_length1 = _tmp6__length1;
#line 882 "DBusAccelerator.c"
	}
#line 123 "../src/DBusAccelerator.vala"
	result = _tmp6_;
#line 123 "../src/DBusAccelerator.vala"
	return result;
#line 888 "DBusAccelerator.c"
}

gboolean
gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                          guint action,
                                          GError** error)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	gboolean result;
#line 126 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../src/DBusAccelerator.vala"
	_tmp0_ = self->priv->grabbed_accelerators;
#line 127 "../src/DBusAccelerator.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 905 "DBusAccelerator.c"
	{
		GList* accel_collection = NULL;
		GList* accel_it = NULL;
#line 127 "../src/DBusAccelerator.vala"
		accel_collection = _tmp1_;
#line 127 "../src/DBusAccelerator.vala"
		for (accel_it = accel_collection; accel_it != NULL; accel_it = accel_it->next) {
#line 913 "DBusAccelerator.c"
			GalaGrabbedAccelerator* accel = NULL;
#line 127 "../src/DBusAccelerator.vala"
			accel = (GalaGrabbedAccelerator*) accel_it->data;
#line 917 "DBusAccelerator.c"
			{
				GalaGrabbedAccelerator* _tmp2_;
#line 128 "../src/DBusAccelerator.vala"
				_tmp2_ = accel;
#line 128 "../src/DBusAccelerator.vala"
				if (_tmp2_->action == action) {
#line 924 "DBusAccelerator.c"
					gboolean ret = FALSE;
					GalaWindowManager* _tmp3_;
					MetaDisplay* _tmp4_;
					GHashTable* _tmp5_;
					GalaGrabbedAccelerator* _tmp6_;
					const gchar* _tmp7_;
#line 129 "../src/DBusAccelerator.vala"
					_tmp3_ = self->priv->wm;
#line 129 "../src/DBusAccelerator.vala"
					_tmp4_ = meta_plugin_get_display ((MetaPlugin*) _tmp3_);
#line 129 "../src/DBusAccelerator.vala"
					ret = meta_display_ungrab_accelerator (_tmp4_, action);
#line 130 "../src/DBusAccelerator.vala"
					_tmp5_ = self->priv->grabbed_accelerators;
#line 130 "../src/DBusAccelerator.vala"
					_tmp6_ = accel;
#line 130 "../src/DBusAccelerator.vala"
					_tmp7_ = _tmp6_->name;
#line 130 "../src/DBusAccelerator.vala"
					g_hash_table_remove (_tmp5_, _tmp7_);
#line 131 "../src/DBusAccelerator.vala"
					result = ret;
#line 131 "../src/DBusAccelerator.vala"
					(accel_collection == NULL) ? NULL : (accel_collection = (g_list_free (accel_collection), NULL));
#line 131 "../src/DBusAccelerator.vala"
					return result;
#line 951 "DBusAccelerator.c"
				}
			}
		}
#line 127 "../src/DBusAccelerator.vala"
		(accel_collection == NULL) ? NULL : (accel_collection = (g_list_free (accel_collection), NULL));
#line 957 "DBusAccelerator.c"
	}
#line 135 "../src/DBusAccelerator.vala"
	result = FALSE;
#line 135 "../src/DBusAccelerator.vala"
	return result;
#line 963 "DBusAccelerator.c"
}

gboolean
gala_dbus_accelerator_ungrab_accelerators (GalaDBusAccelerator* self,
                                           guint* actions,
                                           gint actions_length1,
                                           GError** error)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 138 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 976 "DBusAccelerator.c"
	{
		guint* action_collection = NULL;
		gint action_collection_length1 = 0;
		gint _action_collection_size_ = 0;
		gint action_it = 0;
#line 139 "../src/DBusAccelerator.vala"
		action_collection = actions;
#line 139 "../src/DBusAccelerator.vala"
		action_collection_length1 = actions_length1;
#line 139 "../src/DBusAccelerator.vala"
		for (action_it = 0; action_it < action_collection_length1; action_it = action_it + 1) {
#line 988 "DBusAccelerator.c"
			guint action = 0U;
#line 139 "../src/DBusAccelerator.vala"
			action = action_collection[action_it];
#line 992 "DBusAccelerator.c"
			{
#line 140 "../src/DBusAccelerator.vala"
				gala_dbus_accelerator_ungrab_accelerator (self, action, &_inner_error0_);
#line 140 "../src/DBusAccelerator.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "../src/DBusAccelerator.vala"
					if ((_inner_error0_->domain == G_DBUS_ERROR) || (_inner_error0_->domain == G_IO_ERROR)) {
#line 1000 "DBusAccelerator.c"
						gboolean _tmp0_ = FALSE;
#line 140 "../src/DBusAccelerator.vala"
						g_propagate_error (error, _inner_error0_);
#line 140 "../src/DBusAccelerator.vala"
						return _tmp0_;
#line 1006 "DBusAccelerator.c"
					} else {
						gboolean _tmp1_ = FALSE;
#line 140 "../src/DBusAccelerator.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 140 "../src/DBusAccelerator.vala"
						g_clear_error (&_inner_error0_);
#line 140 "../src/DBusAccelerator.vala"
						return _tmp1_;
#line 1015 "DBusAccelerator.c"
					}
				}
			}
		}
	}
#line 143 "../src/DBusAccelerator.vala"
	result = TRUE;
#line 143 "../src/DBusAccelerator.vala"
	return result;
#line 1025 "DBusAccelerator.c"
}

void
gala_dbus_accelerator_show_osd (GalaDBusAccelerator* self,
                                GHashTable* parameters,
                                GError** error)
{
	gint32 monitor_index = 0;
	gchar* icon = NULL;
	gchar* _tmp1_;
	gchar* label = NULL;
	gchar* _tmp5_;
	gint32 level = 0;
	const gchar* _tmp10_;
#line 147 "../src/DBusAccelerator.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/DBusAccelerator.vala"
	g_return_if_fail (parameters != NULL);
#line 148 "../src/DBusAccelerator.vala"
	monitor_index = (gint32) -1;
#line 149 "../src/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "monitor")) {
#line 1048 "DBusAccelerator.c"
		gconstpointer _tmp0_;
#line 150 "../src/DBusAccelerator.vala"
		_tmp0_ = g_hash_table_lookup (parameters, "monitor");
#line 150 "../src/DBusAccelerator.vala"
		monitor_index = g_variant_get_int32 ((GVariant*) _tmp0_);
#line 1054 "DBusAccelerator.c"
	}
#line 151 "../src/DBusAccelerator.vala"
	_tmp1_ = g_strdup ("");
#line 151 "../src/DBusAccelerator.vala"
	icon = _tmp1_;
#line 152 "../src/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "icon")) {
#line 1062 "DBusAccelerator.c"
		gconstpointer _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 153 "../src/DBusAccelerator.vala"
		_tmp2_ = g_hash_table_lookup (parameters, "icon");
#line 153 "../src/DBusAccelerator.vala"
		_tmp3_ = g_variant_get_string ((GVariant*) _tmp2_, NULL);
#line 153 "../src/DBusAccelerator.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 153 "../src/DBusAccelerator.vala"
		_g_free0 (icon);
#line 153 "../src/DBusAccelerator.vala"
		icon = _tmp4_;
#line 1076 "DBusAccelerator.c"
	}
#line 154 "../src/DBusAccelerator.vala"
	_tmp5_ = g_strdup ("");
#line 154 "../src/DBusAccelerator.vala"
	label = _tmp5_;
#line 155 "../src/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "label")) {
#line 1084 "DBusAccelerator.c"
		gconstpointer _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 156 "../src/DBusAccelerator.vala"
		_tmp6_ = g_hash_table_lookup (parameters, "label");
#line 156 "../src/DBusAccelerator.vala"
		_tmp7_ = g_variant_get_string ((GVariant*) _tmp6_, NULL);
#line 156 "../src/DBusAccelerator.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 156 "../src/DBusAccelerator.vala"
		_g_free0 (label);
#line 156 "../src/DBusAccelerator.vala"
		label = _tmp8_;
#line 1098 "DBusAccelerator.c"
	}
#line 157 "../src/DBusAccelerator.vala"
	level = (gint32) 0;
#line 158 "../src/DBusAccelerator.vala"
	if (g_hash_table_contains (parameters, "level")) {
#line 1104 "DBusAccelerator.c"
		gdouble double_level = 0.0;
		gconstpointer _tmp9_;
#line 159 "../src/DBusAccelerator.vala"
		_tmp9_ = g_hash_table_lookup (parameters, "level");
#line 159 "../src/DBusAccelerator.vala"
		double_level = g_variant_get_double ((GVariant*) _tmp9_);
#line 160 "../src/DBusAccelerator.vala"
		level = (gint32) ((gint) (double_level * 100));
#line 1113 "DBusAccelerator.c"
	}
#line 163 "../src/DBusAccelerator.vala"
	_tmp10_ = icon;
#line 163 "../src/DBusAccelerator.vala"
	gala_media_feedback_send (_tmp10_, (gint) level);
#line 147 "../src/DBusAccelerator.vala"
	_g_free0 (label);
#line 147 "../src/DBusAccelerator.vala"
	_g_free0 (icon);
#line 1123 "DBusAccelerator.c"
}

static void
g_cclosure_user_marshal_VOID__UINT_BOXED (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_BOXED) (gpointer data1, guint arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 59 "../src/DBusAccelerator.vala"
	g_return_if_fail (n_param_values == 3);
#line 59 "../src/DBusAccelerator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 59 "../src/DBusAccelerator.vala"
		data1 = closure->data;
#line 59 "../src/DBusAccelerator.vala"
		data2 = param_values->data[0].v_pointer;
#line 1148 "DBusAccelerator.c"
	} else {
#line 59 "../src/DBusAccelerator.vala"
		data1 = param_values->data[0].v_pointer;
#line 59 "../src/DBusAccelerator.vala"
		data2 = closure->data;
#line 1154 "DBusAccelerator.c"
	}
#line 59 "../src/DBusAccelerator.vala"
	callback = (GMarshalFunc_VOID__UINT_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 59 "../src/DBusAccelerator.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 1160 "DBusAccelerator.c"
}

static void
gala_value_dbus_accelerator_init (GValue* value)
{
#line 59 "../src/DBusAccelerator.vala"
	value->data[0].v_pointer = NULL;
#line 1168 "DBusAccelerator.c"
}

static void
gala_value_dbus_accelerator_free_value (GValue* value)
{
#line 59 "../src/DBusAccelerator.vala"
	if (value->data[0].v_pointer) {
#line 59 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (value->data[0].v_pointer);
#line 1178 "DBusAccelerator.c"
	}
}

static void
gala_value_dbus_accelerator_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 59 "../src/DBusAccelerator.vala"
	if (src_value->data[0].v_pointer) {
#line 59 "../src/DBusAccelerator.vala"
		dest_value->data[0].v_pointer = gala_dbus_accelerator_ref (src_value->data[0].v_pointer);
#line 1190 "DBusAccelerator.c"
	} else {
#line 59 "../src/DBusAccelerator.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1194 "DBusAccelerator.c"
	}
}

static gpointer
gala_value_dbus_accelerator_peek_pointer (const GValue* value)
{
#line 59 "../src/DBusAccelerator.vala"
	return value->data[0].v_pointer;
#line 1203 "DBusAccelerator.c"
}

static gchar*
gala_value_dbus_accelerator_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 59 "../src/DBusAccelerator.vala"
	if (collect_values[0].v_pointer) {
#line 1214 "DBusAccelerator.c"
		GalaDBusAccelerator * object;
		object = collect_values[0].v_pointer;
#line 59 "../src/DBusAccelerator.vala"
		if (object->parent_instance.g_class == NULL) {
#line 59 "../src/DBusAccelerator.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1221 "DBusAccelerator.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 59 "../src/DBusAccelerator.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1225 "DBusAccelerator.c"
		}
#line 59 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = gala_dbus_accelerator_ref (object);
#line 1229 "DBusAccelerator.c"
	} else {
#line 59 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1233 "DBusAccelerator.c"
	}
#line 59 "../src/DBusAccelerator.vala"
	return NULL;
#line 1237 "DBusAccelerator.c"
}

static gchar*
gala_value_dbus_accelerator_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	GalaDBusAccelerator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 59 "../src/DBusAccelerator.vala"
	if (!object_p) {
#line 59 "../src/DBusAccelerator.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1252 "DBusAccelerator.c"
	}
#line 59 "../src/DBusAccelerator.vala"
	if (!value->data[0].v_pointer) {
#line 59 "../src/DBusAccelerator.vala"
		*object_p = NULL;
#line 1258 "DBusAccelerator.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 59 "../src/DBusAccelerator.vala"
		*object_p = value->data[0].v_pointer;
#line 1262 "DBusAccelerator.c"
	} else {
#line 59 "../src/DBusAccelerator.vala"
		*object_p = gala_dbus_accelerator_ref (value->data[0].v_pointer);
#line 1266 "DBusAccelerator.c"
	}
#line 59 "../src/DBusAccelerator.vala"
	return NULL;
#line 1270 "DBusAccelerator.c"
}

GParamSpec*
gala_param_spec_dbus_accelerator (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	GalaParamSpecDBusAccelerator* spec;
#line 59 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GALA_TYPE_DBUS_ACCELERATOR), NULL);
#line 59 "../src/DBusAccelerator.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 59 "../src/DBusAccelerator.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 59 "../src/DBusAccelerator.vala"
	return G_PARAM_SPEC (spec);
#line 1289 "DBusAccelerator.c"
}

gpointer
gala_value_get_dbus_accelerator (const GValue* value)
{
#line 59 "../src/DBusAccelerator.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR), NULL);
#line 59 "../src/DBusAccelerator.vala"
	return value->data[0].v_pointer;
#line 1299 "DBusAccelerator.c"
}

void
gala_value_set_dbus_accelerator (GValue* value,
                                 gpointer v_object)
{
	GalaDBusAccelerator * old;
#line 59 "../src/DBusAccelerator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR));
#line 59 "../src/DBusAccelerator.vala"
	old = value->data[0].v_pointer;
#line 59 "../src/DBusAccelerator.vala"
	if (v_object) {
#line 59 "../src/DBusAccelerator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_DBUS_ACCELERATOR));
#line 59 "../src/DBusAccelerator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 59 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = v_object;
#line 59 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_ref (value->data[0].v_pointer);
#line 1321 "DBusAccelerator.c"
	} else {
#line 59 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1325 "DBusAccelerator.c"
	}
#line 59 "../src/DBusAccelerator.vala"
	if (old) {
#line 59 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (old);
#line 1331 "DBusAccelerator.c"
	}
}

void
gala_value_take_dbus_accelerator (GValue* value,
                                  gpointer v_object)
{
	GalaDBusAccelerator * old;
#line 59 "../src/DBusAccelerator.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_DBUS_ACCELERATOR));
#line 59 "../src/DBusAccelerator.vala"
	old = value->data[0].v_pointer;
#line 59 "../src/DBusAccelerator.vala"
	if (v_object) {
#line 59 "../src/DBusAccelerator.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_DBUS_ACCELERATOR));
#line 59 "../src/DBusAccelerator.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 59 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = v_object;
#line 1352 "DBusAccelerator.c"
	} else {
#line 59 "../src/DBusAccelerator.vala"
		value->data[0].v_pointer = NULL;
#line 1356 "DBusAccelerator.c"
	}
#line 59 "../src/DBusAccelerator.vala"
	if (old) {
#line 59 "../src/DBusAccelerator.vala"
		gala_dbus_accelerator_unref (old);
#line 1362 "DBusAccelerator.c"
	}
}

static void
gala_dbus_accelerator_class_init (GalaDBusAcceleratorClass * klass,
                                  gpointer klass_data)
{
#line 59 "../src/DBusAccelerator.vala"
	gala_dbus_accelerator_parent_class = g_type_class_peek_parent (klass);
#line 59 "../src/DBusAccelerator.vala"
	((GalaDBusAcceleratorClass *) klass)->finalize = gala_dbus_accelerator_finalize;
#line 59 "../src/DBusAccelerator.vala"
	g_type_class_adjust_private_offset (klass, &GalaDBusAccelerator_private_offset);
#line 59 "../src/DBusAccelerator.vala"
	gala_dbus_accelerator_signals[GALA_DBUS_ACCELERATOR_ACCELERATOR_ACTIVATED_SIGNAL] = g_signal_new ("accelerator-activated", GALA_TYPE_DBUS_ACCELERATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_BOXED, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_HASH_TABLE);
#line 1378 "DBusAccelerator.c"
}

static void
gala_dbus_accelerator_instance_init (GalaDBusAccelerator * self,
                                     gpointer klass)
{
#line 59 "../src/DBusAccelerator.vala"
	self->priv = gala_dbus_accelerator_get_instance_private (self);
#line 59 "../src/DBusAccelerator.vala"
	self->ref_count = 1;
#line 1389 "DBusAccelerator.c"
}

static void
gala_dbus_accelerator_finalize (GalaDBusAccelerator * obj)
{
	GalaDBusAccelerator * self;
#line 59 "../src/DBusAccelerator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DBUS_ACCELERATOR, GalaDBusAccelerator);
#line 59 "../src/DBusAccelerator.vala"
	g_signal_handlers_destroy (self);
#line 72 "../src/DBusAccelerator.vala"
	_g_object_unref0 (self->priv->wm);
#line 73 "../src/DBusAccelerator.vala"
	_g_hash_table_unref0 (self->priv->grabbed_accelerators);
#line 1404 "DBusAccelerator.c"
}

static GType
gala_dbus_accelerator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gala_value_dbus_accelerator_init, gala_value_dbus_accelerator_free_value, gala_value_dbus_accelerator_copy_value, gala_value_dbus_accelerator_peek_pointer, "p", gala_value_dbus_accelerator_collect_value, "p", gala_value_dbus_accelerator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GalaDBusAcceleratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_dbus_accelerator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDBusAccelerator), 0, (GInstanceInitFunc) gala_dbus_accelerator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gala_dbus_accelerator_type_id;
	gala_dbus_accelerator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaDBusAccelerator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	g_type_set_qdata (gala_dbus_accelerator_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gala_dbus_accelerator_register_object);
	GalaDBusAccelerator_private_offset = g_type_add_instance_private (gala_dbus_accelerator_type_id, sizeof (GalaDBusAcceleratorPrivate));
	return gala_dbus_accelerator_type_id;
}

GType
gala_dbus_accelerator_get_type (void)
{
	static volatile gsize gala_dbus_accelerator_type_id__once = 0;
	if (g_once_init_enter (&gala_dbus_accelerator_type_id__once)) {
		GType gala_dbus_accelerator_type_id;
		gala_dbus_accelerator_type_id = gala_dbus_accelerator_get_type_once ();
		g_once_init_leave (&gala_dbus_accelerator_type_id__once, gala_dbus_accelerator_type_id);
	}
	return gala_dbus_accelerator_type_id__once;
}

gpointer
gala_dbus_accelerator_ref (gpointer instance)
{
	GalaDBusAccelerator * self;
	self = instance;
#line 59 "../src/DBusAccelerator.vala"
	g_atomic_int_inc (&self->ref_count);
#line 59 "../src/DBusAccelerator.vala"
	return instance;
#line 1441 "DBusAccelerator.c"
}

void
gala_dbus_accelerator_unref (gpointer instance)
{
	GalaDBusAccelerator * self;
	self = instance;
#line 59 "../src/DBusAccelerator.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 59 "../src/DBusAccelerator.vala"
		GALA_DBUS_ACCELERATOR_GET_CLASS (self)->finalize (self);
#line 59 "../src/DBusAccelerator.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1455 "DBusAccelerator.c"
	}
}

static void
_dbus_gala_dbus_accelerator_grab_accelerator (GalaDBusAccelerator* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* accelerator = NULL;
	GVariant* _tmp7_;
	GalaActionMode flags = 0U;
	GVariant* _tmp8_;
	MetaKeyBindingFlags grab_flags = 0U;
	GVariant* _tmp9_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	accelerator = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint32 (_tmp8_);
	g_variant_unref (_tmp8_);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	grab_flags = g_variant_get_uint32 (_tmp9_);
	g_variant_unref (_tmp9_);
	result = gala_dbus_accelerator_grab_accelerator (self, accelerator, flags, grab_flags, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (accelerator);
	;
}

static void
_vala_GalaAccelerator_array_free (GalaAccelerator * array,
                                  gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			gala_accelerator_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_gala_dbus_accelerator_grab_accelerators (GalaDBusAccelerator* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GalaAccelerator* accelerators = NULL;
	gint accelerators_length1 = 0;
	GVariant* _tmp10_;
	GalaAccelerator* _tmp11_;
	gint _tmp11__length;
	gint _tmp11__size;
	gint _tmp11__length1;
	GVariantIter _tmp12_;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint* result;
	gint result_length1 = 0;
	guint* _tmp19_;
	GVariantBuilder _tmp20_;
	gint _tmp21_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp10_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp11_ = g_new (GalaAccelerator, 5);
	_tmp11__length = 0;
	_tmp11__size = 4;
	_tmp11__length1 = 0;
	g_variant_iter_init (&_tmp12_, _tmp10_);
	for (; (_tmp13_ = g_variant_iter_next_value (&_tmp12_)) != NULL; _tmp11__length1++) {
		GalaAccelerator _tmp14_;
		GVariantIter _tmp15_;
		GVariant* _tmp16_;
		GVariant* _tmp17_;
		GVariant* _tmp18_;
		if (_tmp11__size == _tmp11__length) {
			_tmp11__size = 2 * _tmp11__size;
			_tmp11_ = g_renew (GalaAccelerator, _tmp11_, _tmp11__size + 1);
		}
		g_variant_iter_init (&_tmp15_, _tmp13_);
		_tmp16_ = g_variant_iter_next_value (&_tmp15_);
		_tmp14_.name = g_variant_dup_string (_tmp16_, NULL);
		g_variant_unref (_tmp16_);
		_tmp17_ = g_variant_iter_next_value (&_tmp15_);
		_tmp14_.flags = g_variant_get_uint32 (_tmp17_);
		g_variant_unref (_tmp17_);
		_tmp18_ = g_variant_iter_next_value (&_tmp15_);
		_tmp14_.grab_flags = g_variant_get_uint32 (_tmp18_);
		g_variant_unref (_tmp18_);
		_tmp11_[_tmp11__length++] = _tmp14_;
		g_variant_unref (_tmp13_);
	}
	accelerators_length1 = _tmp11__length1;
	accelerators = _tmp11_;
	g_variant_unref (_tmp10_);
	result = gala_dbus_accelerator_grab_accelerators (self, accelerators, accelerators_length1, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp19_ = result;
	g_variant_builder_init (&_tmp20_, G_VARIANT_TYPE ("au"));
	for (_tmp21_ = 0; _tmp21_ < result_length1; _tmp21_++) {
		g_variant_builder_add_value (&_tmp20_, g_variant_new_uint32 (*_tmp19_));
		_tmp19_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp20_));
	result = (g_free (result), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	accelerators = (_vala_GalaAccelerator_array_free (accelerators, accelerators_length1), NULL);
	;
}

static void
_dbus_gala_dbus_accelerator_ungrab_accelerator (GalaDBusAccelerator* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint action = 0U;
	GVariant* _tmp22_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp22_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_get_uint32 (_tmp22_);
	g_variant_unref (_tmp22_);
	result = gala_dbus_accelerator_ungrab_accelerator (self, action, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_gala_dbus_accelerator_ungrab_accelerators (GalaDBusAccelerator* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint* actions = NULL;
	gint actions_length1 = 0;
	GVariant* _tmp23_;
	guint* _tmp24_;
	gint _tmp24__length;
	gint _tmp24__size;
	gint _tmp24__length1;
	GVariantIter _tmp25_;
	GVariant* _tmp26_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp23_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp24_ = g_new (guint, 5);
	_tmp24__length = 0;
	_tmp24__size = 4;
	_tmp24__length1 = 0;
	g_variant_iter_init (&_tmp25_, _tmp23_);
	for (; (_tmp26_ = g_variant_iter_next_value (&_tmp25_)) != NULL; _tmp24__length1++) {
		if (_tmp24__size == _tmp24__length) {
			_tmp24__size = 2 * _tmp24__size;
			_tmp24_ = g_renew (guint, _tmp24_, _tmp24__size + 1);
		}
		_tmp24_[_tmp24__length++] = g_variant_get_uint32 (_tmp26_);
		g_variant_unref (_tmp26_);
	}
	actions_length1 = _tmp24__length1;
	actions = _tmp24_;
	g_variant_unref (_tmp23_);
	result = gala_dbus_accelerator_ungrab_accelerators (self, actions, actions_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	actions = (g_free (actions), NULL);
	;
}

static void
_dbus_gala_dbus_accelerator_show_osd (GalaDBusAccelerator* self,
                                      GVariant* _parameters_,
                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* parameters = NULL;
	GVariant* _tmp27_;
	GHashTable* _tmp28_;
	GVariantIter _tmp29_;
	GVariant* _tmp30_;
	GVariant* _tmp31_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp27_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp28_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp29_, _tmp27_);
	while (g_variant_iter_loop (&_tmp29_, "{?*}", &_tmp30_, &_tmp31_)) {
		g_hash_table_insert (_tmp28_, g_variant_dup_string (_tmp30_, NULL), g_variant_get_variant (_tmp31_));
	}
	parameters = _tmp28_;
	g_variant_unref (_tmp27_);
	gala_dbus_accelerator_show_osd (self, parameters, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_hash_table_unref0 (parameters);
	;
}

static void
gala_dbus_accelerator_dbus_interface_method_call (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* method_name,
                                                  GVariant* parameters,
                                                  GDBusMethodInvocation* invocation,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GrabAccelerator") == 0) {
		_dbus_gala_dbus_accelerator_grab_accelerator (object, parameters, invocation);
	} else if (strcmp (method_name, "GrabAccelerators") == 0) {
		_dbus_gala_dbus_accelerator_grab_accelerators (object, parameters, invocation);
	} else if (strcmp (method_name, "UngrabAccelerator") == 0) {
		_dbus_gala_dbus_accelerator_ungrab_accelerator (object, parameters, invocation);
	} else if (strcmp (method_name, "UngrabAccelerators") == 0) {
		_dbus_gala_dbus_accelerator_ungrab_accelerators (object, parameters, invocation);
	} else if (strcmp (method_name, "ShowOSD") == 0) {
		_dbus_gala_dbus_accelerator_show_osd (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
gala_dbus_accelerator_dbus_interface_get_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GError** error,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
gala_dbus_accelerator_dbus_interface_set_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GVariant* value,
                                                   GError** error,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_gala_dbus_accelerator_accelerator_activated (GObject* _sender,
                                                   guint action,
                                                   GHashTable* parameters,
                                                   gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp32_;
	GHashTableIter _tmp33_;
	gpointer _tmp34_;
	gpointer _tmp35_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (action));
	g_hash_table_iter_init (&_tmp33_, parameters);
	g_variant_builder_init (&_tmp32_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp33_, &_tmp34_, &_tmp35_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp34_;
		_value = (GVariant*) _tmp35_;
		g_variant_builder_add (&_tmp32_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp32_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.Shell", "AcceleratorActivated", _arguments, NULL);
}

guint
gala_dbus_accelerator_register_object (gpointer object,
                                       GDBusConnection* connection,
                                       const gchar* path,
                                       GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = gala_dbus_accelerator_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gala_dbus_accelerator_dbus_interface_info), &_gala_dbus_accelerator_dbus_interface_vtable, data, _gala_dbus_accelerator_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "accelerator-activated", (GCallback) _dbus_gala_dbus_accelerator_accelerator_activated, data);
	return result;
}

static void
_gala_dbus_accelerator_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gala_dbus_accelerator_accelerator_activated, data);
	gala_dbus_accelerator_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

