/* Tooltip.c generated by valac 0.56.14, the Vala compiler
 * generated from Tooltip.vala, do not modify */

/*
 * Copyright 2021 José Expósito <jose.exposito89@gmail.com>
 * Copyright 2021-2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <clutter/clutter.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <cairo-gobject.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_TOOLTIP (gala_tooltip_get_type ())
#define GALA_TOOLTIP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_TOOLTIP, GalaTooltip))
#define GALA_TOOLTIP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_TOOLTIP, GalaTooltipClass))
#define GALA_IS_TOOLTIP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_TOOLTIP))
#define GALA_IS_TOOLTIP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_TOOLTIP))
#define GALA_TOOLTIP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_TOOLTIP, GalaTooltipClass))

typedef struct _GalaTooltip GalaTooltip;
typedef struct _GalaTooltipClass GalaTooltipClass;
typedef struct _GalaTooltipPrivate GalaTooltipPrivate;
enum  {
	GALA_TOOLTIP_0_PROPERTY,
	GALA_TOOLTIP_NUM_PROPERTIES
};
static GParamSpec* gala_tooltip_properties[GALA_TOOLTIP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_widget_path_unref0(var) ((var == NULL) ? NULL : (var = (gtk_widget_path_unref (var), NULL)))

struct _GalaTooltip {
	ClutterActor parent_instance;
	GalaTooltipPrivate * priv;
	gfloat max_width;
};

struct _GalaTooltipClass {
	ClutterActorClass parent_class;
};

struct _GalaTooltipPrivate {
	ClutterCanvas* background_canvas;
	ClutterText* text_actor;
	gchar* text;
};

static gint GalaTooltip_private_offset;
static gpointer gala_tooltip_parent_class = NULL;
static ClutterColor gala_tooltip_text_color;
static ClutterColor gala_tooltip_text_color = {0};
static GtkBorder gala_tooltip_padding;
static GtkBorder gala_tooltip_padding = {0};
static GtkStyleContext* gala_tooltip_style_context;
static GtkStyleContext* gala_tooltip_style_context = NULL;

VALA_EXTERN GType gala_tooltip_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaTooltip, g_object_unref)
static void gala_tooltip_create_gtk_objects (void);
VALA_EXTERN void gala_tooltip_set_text (GalaTooltip* self,
                            const gchar* new_text,
                            gboolean redraw);
static void gala_tooltip_draw (GalaTooltip* self);
VALA_EXTERN void gala_tooltip_set_max_width (GalaTooltip* self,
                                 gfloat new_max_width,
                                 gboolean redraw);
static gboolean gala_tooltip_draw_background (cairo_t* ctx,
                                       gint width,
                                       gint height);
VALA_EXTERN GalaTooltip* gala_tooltip_new (void);
VALA_EXTERN GalaTooltip* gala_tooltip_construct (GType object_type);
static GObject * gala_tooltip_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static gboolean _gala_tooltip_draw_background_clutter_canvas_draw (ClutterCanvas* _sender,
                                                            cairo_t* cr,
                                                            gint width,
                                                            gint height,
                                                            gpointer self);
static void gala_tooltip_finalize (GObject * obj);
static GType gala_tooltip_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_tooltip_get_instance_private (GalaTooltip* self)
{
	return G_STRUCT_MEMBER_P (self, GalaTooltip_private_offset);
}

static void
gala_tooltip_create_gtk_objects (void)
{
	GtkWidgetPath* tooltip_widget_path = NULL;
	GtkWidgetPath* _tmp0_;
	gint pos = 0;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkBorder _tmp4_ = {0};
	GtkStyleContext* label_style_context = NULL;
	GtkStyleContext* _tmp5_;
	GdkRGBA text_rgba = {0};
	GValue _tmp6_ = {0};
	GValue _tmp7_;
	GdkRGBA* _tmp8_;
	GdkRGBA _tmp9_ = {0};
	GdkRGBA _tmp10_;
	GdkRGBA _tmp11_;
	GdkRGBA _tmp12_;
	GdkRGBA _tmp13_;
	GdkRGBA _tmp14_;
	ClutterColor _tmp15_ = {0};
#line 49 "../src/Widgets/Tooltip.vala"
	_tmp0_ = gtk_widget_path_new ();
#line 49 "../src/Widgets/Tooltip.vala"
	tooltip_widget_path = _tmp0_;
#line 50 "../src/Widgets/Tooltip.vala"
	pos = gtk_widget_path_append_type (tooltip_widget_path, gtk_window_get_type ());
#line 51 "../src/Widgets/Tooltip.vala"
	gtk_widget_path_iter_set_object_name (tooltip_widget_path, pos, "tooltip");
#line 52 "../src/Widgets/Tooltip.vala"
	gtk_widget_path_iter_add_class (tooltip_widget_path, pos, GTK_STYLE_CLASS_CSD);
#line 53 "../src/Widgets/Tooltip.vala"
	gtk_widget_path_iter_add_class (tooltip_widget_path, pos, GTK_STYLE_CLASS_BACKGROUND);
#line 55 "../src/Widgets/Tooltip.vala"
	_tmp1_ = gtk_style_context_new ();
#line 55 "../src/Widgets/Tooltip.vala"
	_g_object_unref0 (gala_tooltip_style_context);
#line 55 "../src/Widgets/Tooltip.vala"
	gala_tooltip_style_context = _tmp1_;
#line 56 "../src/Widgets/Tooltip.vala"
	_tmp2_ = gala_tooltip_style_context;
#line 56 "../src/Widgets/Tooltip.vala"
	gtk_style_context_set_path (_tmp2_, tooltip_widget_path);
#line 58 "../src/Widgets/Tooltip.vala"
	_tmp3_ = gala_tooltip_style_context;
#line 58 "../src/Widgets/Tooltip.vala"
	gtk_style_context_get_padding (_tmp3_, GTK_STATE_FLAG_NORMAL, &_tmp4_);
#line 58 "../src/Widgets/Tooltip.vala"
	gala_tooltip_padding = _tmp4_;
#line 60 "../src/Widgets/Tooltip.vala"
	gtk_widget_path_append_type (tooltip_widget_path, gtk_label_get_type ());
#line 62 "../src/Widgets/Tooltip.vala"
	_tmp5_ = gtk_style_context_new ();
#line 62 "../src/Widgets/Tooltip.vala"
	label_style_context = _tmp5_;
#line 63 "../src/Widgets/Tooltip.vala"
	gtk_style_context_set_path (label_style_context, tooltip_widget_path);
#line 65 "../src/Widgets/Tooltip.vala"
	gtk_style_context_get_property (label_style_context, GTK_STYLE_PROPERTY_COLOR, GTK_STATE_FLAG_NORMAL, &_tmp6_);
#line 65 "../src/Widgets/Tooltip.vala"
	_tmp7_ = _tmp6_;
#line 65 "../src/Widgets/Tooltip.vala"
	_tmp8_ = g_value_get_boxed (&_tmp6_);
#line 65 "../src/Widgets/Tooltip.vala"
	_tmp10_ = (G_VALUE_HOLDS (&_tmp6_, gdk_rgba_get_type ()) && _tmp8_) ? (*_tmp8_) : (g_warning ("Invalid GValue unboxing (wrong type or NULL)"), _tmp9_);
#line 65 "../src/Widgets/Tooltip.vala"
	G_IS_VALUE (&_tmp7_) ? (g_value_unset (&_tmp7_), NULL) : NULL;
#line 65 "../src/Widgets/Tooltip.vala"
	text_rgba = _tmp10_;
#line 70 "../src/Widgets/Tooltip.vala"
	_tmp11_ = text_rgba;
#line 70 "../src/Widgets/Tooltip.vala"
	_tmp12_ = text_rgba;
#line 70 "../src/Widgets/Tooltip.vala"
	_tmp13_ = text_rgba;
#line 70 "../src/Widgets/Tooltip.vala"
	_tmp14_ = text_rgba;
#line 70 "../src/Widgets/Tooltip.vala"
	memset (&_tmp15_, 0, sizeof (ClutterColor));
#line 70 "../src/Widgets/Tooltip.vala"
	_tmp15_.red = ((guint8) _tmp11_.red) * G_MAXUINT8;
#line 70 "../src/Widgets/Tooltip.vala"
	_tmp15_.green = ((guint8) _tmp12_.green) * G_MAXUINT8;
#line 70 "../src/Widgets/Tooltip.vala"
	_tmp15_.blue = ((guint8) _tmp13_.blue) * G_MAXUINT8;
#line 70 "../src/Widgets/Tooltip.vala"
	_tmp15_.alpha = ((guint8) _tmp14_.alpha) * G_MAXUINT8;
#line 70 "../src/Widgets/Tooltip.vala"
	gala_tooltip_text_color = _tmp15_;
#line 48 "../src/Widgets/Tooltip.vala"
	_g_object_unref0 (label_style_context);
#line 48 "../src/Widgets/Tooltip.vala"
	_gtk_widget_path_unref0 (tooltip_widget_path);
#line 212 "Tooltip.c"
}

void
gala_tooltip_set_text (GalaTooltip* self,
                       const gchar* new_text,
                       gboolean redraw)
{
	gchar* _tmp0_;
#line 78 "../src/Widgets/Tooltip.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/Widgets/Tooltip.vala"
	g_return_if_fail (new_text != NULL);
#line 79 "../src/Widgets/Tooltip.vala"
	_tmp0_ = g_strdup (new_text);
#line 79 "../src/Widgets/Tooltip.vala"
	_g_free0 (self->priv->text);
#line 79 "../src/Widgets/Tooltip.vala"
	self->priv->text = _tmp0_;
#line 81 "../src/Widgets/Tooltip.vala"
	if (redraw) {
#line 82 "../src/Widgets/Tooltip.vala"
		gala_tooltip_draw (self);
#line 235 "Tooltip.c"
	}
}

void
gala_tooltip_set_max_width (GalaTooltip* self,
                            gfloat new_max_width,
                            gboolean redraw)
{
#line 86 "../src/Widgets/Tooltip.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/Widgets/Tooltip.vala"
	self->max_width = new_max_width;
#line 89 "../src/Widgets/Tooltip.vala"
	if (redraw) {
#line 90 "../src/Widgets/Tooltip.vala"
		gala_tooltip_draw (self);
#line 252 "Tooltip.c"
	}
}

static void
gala_tooltip_draw (GalaTooltip* self)
{
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	ClutterText* _tmp5_;
	ClutterColor _tmp7_;
	GtkBorder _tmp8_;
	GtkBorder _tmp9_;
	ClutterText* _tmp10_ = NULL;
	ClutterText* _tmp11_;
	const gchar* _tmp12_;
	ClutterText* _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	GtkBorder _tmp16_;
	GtkBorder _tmp17_;
	ClutterText* _tmp21_;
	ClutterText* _tmp22_;
	gfloat _tmp23_;
	gfloat _tmp24_;
	GtkBorder _tmp25_;
	GtkBorder _tmp26_;
	ClutterText* _tmp27_;
	gfloat _tmp28_;
	gfloat _tmp29_;
	GtkBorder _tmp30_;
	GtkBorder _tmp31_;
	ClutterCanvas* _tmp32_;
	gfloat _tmp33_;
	gfloat _tmp34_;
	gfloat _tmp35_;
	gfloat _tmp36_;
	ClutterCanvas* _tmp37_;
#line 94 "../src/Widgets/Tooltip.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/Widgets/Tooltip.vala"
	_tmp0_ = self->priv->text;
#line 95 "../src/Widgets/Tooltip.vala"
	_tmp1_ = strlen (_tmp0_);
#line 95 "../src/Widgets/Tooltip.vala"
	_tmp2_ = _tmp1_;
#line 95 "../src/Widgets/Tooltip.vala"
	g_object_set ((ClutterActor*) self, "visible", _tmp2_ != 0, NULL);
#line 97 "../src/Widgets/Tooltip.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp3_, NULL);
#line 97 "../src/Widgets/Tooltip.vala"
	_tmp4_ = _tmp3_;
#line 97 "../src/Widgets/Tooltip.vala"
	if (!_tmp4_) {
#line 98 "../src/Widgets/Tooltip.vala"
		return;
#line 311 "Tooltip.c"
	}
#line 102 "../src/Widgets/Tooltip.vala"
	_tmp5_ = self->priv->text_actor;
#line 102 "../src/Widgets/Tooltip.vala"
	if (_tmp5_ != NULL) {
#line 317 "Tooltip.c"
		ClutterText* _tmp6_;
#line 103 "../src/Widgets/Tooltip.vala"
		_tmp6_ = self->priv->text_actor;
#line 103 "../src/Widgets/Tooltip.vala"
		clutter_actor_remove_child ((ClutterActor*) self, (ClutterActor*) _tmp6_);
#line 323 "Tooltip.c"
	}
#line 106 "../src/Widgets/Tooltip.vala"
	_tmp7_ = gala_tooltip_text_color;
#line 106 "../src/Widgets/Tooltip.vala"
	_tmp8_ = gala_tooltip_padding;
#line 106 "../src/Widgets/Tooltip.vala"
	_tmp9_ = gala_tooltip_padding;
#line 106 "../src/Widgets/Tooltip.vala"
	_tmp10_ = (ClutterText*) clutter_text_new ();
#line 106 "../src/Widgets/Tooltip.vala"
	clutter_text_set_color (_tmp10_, &_tmp7_);
#line 106 "../src/Widgets/Tooltip.vala"
	clutter_actor_set_x ((ClutterActor*) _tmp10_, (gfloat) _tmp8_.left);
#line 106 "../src/Widgets/Tooltip.vala"
	clutter_actor_set_y ((ClutterActor*) _tmp10_, (gfloat) _tmp9_.top);
#line 106 "../src/Widgets/Tooltip.vala"
	clutter_text_set_ellipsize (_tmp10_, PANGO_ELLIPSIZE_MIDDLE);
#line 106 "../src/Widgets/Tooltip.vala"
	g_object_ref_sink (_tmp10_);
#line 106 "../src/Widgets/Tooltip.vala"
	_g_object_unref0 (self->priv->text_actor);
#line 106 "../src/Widgets/Tooltip.vala"
	self->priv->text_actor = _tmp10_;
#line 112 "../src/Widgets/Tooltip.vala"
	_tmp11_ = self->priv->text_actor;
#line 112 "../src/Widgets/Tooltip.vala"
	_tmp12_ = self->priv->text;
#line 112 "../src/Widgets/Tooltip.vala"
	clutter_text_set_text (_tmp11_, _tmp12_);
#line 114 "../src/Widgets/Tooltip.vala"
	_tmp13_ = self->priv->text_actor;
#line 114 "../src/Widgets/Tooltip.vala"
	_tmp14_ = clutter_actor_get_width ((ClutterActor*) _tmp13_);
#line 114 "../src/Widgets/Tooltip.vala"
	_tmp15_ = _tmp14_;
#line 114 "../src/Widgets/Tooltip.vala"
	_tmp16_ = gala_tooltip_padding;
#line 114 "../src/Widgets/Tooltip.vala"
	_tmp17_ = gala_tooltip_padding;
#line 114 "../src/Widgets/Tooltip.vala"
	if (((_tmp15_ + _tmp16_.left) + _tmp17_.right) > self->max_width) {
#line 365 "Tooltip.c"
		ClutterText* _tmp18_;
		GtkBorder _tmp19_;
		GtkBorder _tmp20_;
#line 115 "../src/Widgets/Tooltip.vala"
		_tmp18_ = self->priv->text_actor;
#line 115 "../src/Widgets/Tooltip.vala"
		_tmp19_ = gala_tooltip_padding;
#line 115 "../src/Widgets/Tooltip.vala"
		_tmp20_ = gala_tooltip_padding;
#line 115 "../src/Widgets/Tooltip.vala"
		clutter_actor_set_width ((ClutterActor*) _tmp18_, (self->max_width - _tmp19_.left) - _tmp20_.right);
#line 377 "Tooltip.c"
	}
#line 118 "../src/Widgets/Tooltip.vala"
	_tmp21_ = self->priv->text_actor;
#line 118 "../src/Widgets/Tooltip.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp21_);
#line 121 "../src/Widgets/Tooltip.vala"
	_tmp22_ = self->priv->text_actor;
#line 121 "../src/Widgets/Tooltip.vala"
	_tmp23_ = clutter_actor_get_width ((ClutterActor*) _tmp22_);
#line 121 "../src/Widgets/Tooltip.vala"
	_tmp24_ = _tmp23_;
#line 121 "../src/Widgets/Tooltip.vala"
	_tmp25_ = gala_tooltip_padding;
#line 121 "../src/Widgets/Tooltip.vala"
	_tmp26_ = gala_tooltip_padding;
#line 121 "../src/Widgets/Tooltip.vala"
	clutter_actor_set_width ((ClutterActor*) self, (_tmp24_ + _tmp25_.left) + _tmp26_.right);
#line 122 "../src/Widgets/Tooltip.vala"
	_tmp27_ = self->priv->text_actor;
#line 122 "../src/Widgets/Tooltip.vala"
	_tmp28_ = clutter_actor_get_height ((ClutterActor*) _tmp27_);
#line 122 "../src/Widgets/Tooltip.vala"
	_tmp29_ = _tmp28_;
#line 122 "../src/Widgets/Tooltip.vala"
	_tmp30_ = gala_tooltip_padding;
#line 122 "../src/Widgets/Tooltip.vala"
	_tmp31_ = gala_tooltip_padding;
#line 122 "../src/Widgets/Tooltip.vala"
	clutter_actor_set_height ((ClutterActor*) self, (_tmp29_ + _tmp30_.top) + _tmp31_.bottom);
#line 123 "../src/Widgets/Tooltip.vala"
	_tmp32_ = self->priv->background_canvas;
#line 123 "../src/Widgets/Tooltip.vala"
	_tmp33_ = clutter_actor_get_width ((ClutterActor*) self);
#line 123 "../src/Widgets/Tooltip.vala"
	_tmp34_ = _tmp33_;
#line 123 "../src/Widgets/Tooltip.vala"
	_tmp35_ = clutter_actor_get_height ((ClutterActor*) self);
#line 123 "../src/Widgets/Tooltip.vala"
	_tmp36_ = _tmp35_;
#line 123 "../src/Widgets/Tooltip.vala"
	clutter_canvas_set_size (_tmp32_, (gint) _tmp34_, (gint) _tmp36_);
#line 126 "../src/Widgets/Tooltip.vala"
	_tmp37_ = self->priv->background_canvas;
#line 126 "../src/Widgets/Tooltip.vala"
	clutter_content_invalidate ((ClutterContent*) _tmp37_);
#line 423 "Tooltip.c"
}

static gboolean
gala_tooltip_draw_background (cairo_t* ctx,
                              gint width,
                              gint height)
{
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	gboolean result;
#line 129 "../src/Widgets/Tooltip.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 130 "../src/Widgets/Tooltip.vala"
	_tmp0_ = gala_tooltip_style_context;
#line 130 "../src/Widgets/Tooltip.vala"
	if (_tmp0_ == NULL) {
#line 131 "../src/Widgets/Tooltip.vala"
		gala_tooltip_create_gtk_objects ();
#line 442 "Tooltip.c"
	}
#line 134 "../src/Widgets/Tooltip.vala"
	cairo_save (ctx);
#line 135 "../src/Widgets/Tooltip.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
#line 136 "../src/Widgets/Tooltip.vala"
	cairo_paint (ctx);
#line 137 "../src/Widgets/Tooltip.vala"
	cairo_clip (ctx);
#line 138 "../src/Widgets/Tooltip.vala"
	cairo_reset_clip (ctx);
#line 139 "../src/Widgets/Tooltip.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_OVER);
#line 141 "../src/Widgets/Tooltip.vala"
	_tmp1_ = gala_tooltip_style_context;
#line 141 "../src/Widgets/Tooltip.vala"
	gtk_render_background (_tmp1_, ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
#line 143 "../src/Widgets/Tooltip.vala"
	cairo_restore (ctx);
#line 145 "../src/Widgets/Tooltip.vala"
	result = FALSE;
#line 145 "../src/Widgets/Tooltip.vala"
	return result;
#line 466 "Tooltip.c"
}

GalaTooltip*
gala_tooltip_construct (GType object_type)
{
	GalaTooltip * self = NULL;
#line 10 "../src/Widgets/Tooltip.vala"
	self = (GalaTooltip*) g_object_new (object_type, NULL);
#line 10 "../src/Widgets/Tooltip.vala"
	return self;
#line 477 "Tooltip.c"
}

GalaTooltip*
gala_tooltip_new (void)
{
#line 10 "../src/Widgets/Tooltip.vala"
	return gala_tooltip_construct (GALA_TYPE_TOOLTIP);
#line 485 "Tooltip.c"
}

static gboolean
_gala_tooltip_draw_background_clutter_canvas_draw (ClutterCanvas* _sender,
                                                   cairo_t* cr,
                                                   gint width,
                                                   gint height,
                                                   gpointer self)
{
	gboolean result;
	result = gala_tooltip_draw_background (cr, width, height);
#line 42 "../src/Widgets/Tooltip.vala"
	return result;
#line 499 "Tooltip.c"
}

static GObject *
gala_tooltip_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaTooltip * self;
	gchar* _tmp0_;
	ClutterCanvas* _tmp1_;
	ClutterCanvas* _tmp2_;
	ClutterCanvas* _tmp3_;
#line 37 "../src/Widgets/Tooltip.vala"
	parent_class = G_OBJECT_CLASS (gala_tooltip_parent_class);
#line 37 "../src/Widgets/Tooltip.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/Widgets/Tooltip.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_TOOLTIP, GalaTooltip);
#line 38 "../src/Widgets/Tooltip.vala"
	_tmp0_ = g_strdup ("");
#line 38 "../src/Widgets/Tooltip.vala"
	_g_free0 (self->priv->text);
#line 38 "../src/Widgets/Tooltip.vala"
	self->priv->text = _tmp0_;
#line 39 "../src/Widgets/Tooltip.vala"
	self->max_width = (gfloat) 200;
#line 41 "../src/Widgets/Tooltip.vala"
	_tmp1_ = (ClutterCanvas*) clutter_canvas_new ();
#line 41 "../src/Widgets/Tooltip.vala"
	_g_object_unref0 (self->priv->background_canvas);
#line 41 "../src/Widgets/Tooltip.vala"
	self->priv->background_canvas = _tmp1_;
#line 42 "../src/Widgets/Tooltip.vala"
	_tmp2_ = self->priv->background_canvas;
#line 42 "../src/Widgets/Tooltip.vala"
	g_signal_connect (_tmp2_, "draw", (GCallback) _gala_tooltip_draw_background_clutter_canvas_draw, NULL);
#line 43 "../src/Widgets/Tooltip.vala"
	_tmp3_ = self->priv->background_canvas;
#line 43 "../src/Widgets/Tooltip.vala"
	clutter_actor_set_content ((ClutterActor*) self, (ClutterContent*) _tmp3_);
#line 45 "../src/Widgets/Tooltip.vala"
	gala_tooltip_draw (self);
#line 37 "../src/Widgets/Tooltip.vala"
	return obj;
#line 546 "Tooltip.c"
}

static void
gala_tooltip_class_init (GalaTooltipClass * klass,
                         gpointer klass_data)
{
#line 10 "../src/Widgets/Tooltip.vala"
	gala_tooltip_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/Tooltip.vala"
	g_type_class_adjust_private_offset (klass, &GalaTooltip_private_offset);
#line 10 "../src/Widgets/Tooltip.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_tooltip_constructor;
#line 10 "../src/Widgets/Tooltip.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_tooltip_finalize;
#line 561 "Tooltip.c"
}

static void
gala_tooltip_instance_init (GalaTooltip * self,
                            gpointer klass)
{
#line 10 "../src/Widgets/Tooltip.vala"
	self->priv = gala_tooltip_get_instance_private (self);
#line 23 "../src/Widgets/Tooltip.vala"
	self->priv->text_actor = NULL;
#line 572 "Tooltip.c"
}

static void
gala_tooltip_finalize (GObject * obj)
{
	GalaTooltip * self;
#line 10 "../src/Widgets/Tooltip.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_TOOLTIP, GalaTooltip);
#line 18 "../src/Widgets/Tooltip.vala"
	_g_object_unref0 (self->priv->background_canvas);
#line 23 "../src/Widgets/Tooltip.vala"
	_g_object_unref0 (self->priv->text_actor);
#line 29 "../src/Widgets/Tooltip.vala"
	_g_free0 (self->priv->text);
#line 10 "../src/Widgets/Tooltip.vala"
	G_OBJECT_CLASS (gala_tooltip_parent_class)->finalize (obj);
#line 589 "Tooltip.c"
}

/**
 * Clutter actor to display text in a tooltip-like component.
 */
static GType
gala_tooltip_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaTooltipClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_tooltip_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaTooltip), 0, (GInstanceInitFunc) gala_tooltip_instance_init, NULL };
	GType gala_tooltip_type_id;
	gala_tooltip_type_id = g_type_register_static (clutter_actor_get_type (), "GalaTooltip", &g_define_type_info, 0);
	GalaTooltip_private_offset = g_type_add_instance_private (gala_tooltip_type_id, sizeof (GalaTooltipPrivate));
	return gala_tooltip_type_id;
}

GType
gala_tooltip_get_type (void)
{
	static volatile gsize gala_tooltip_type_id__once = 0;
	if (g_once_init_enter (&gala_tooltip_type_id__once)) {
		GType gala_tooltip_type_id;
		gala_tooltip_type_id = gala_tooltip_get_type_once ();
		g_once_init_leave (&gala_tooltip_type_id__once, gala_tooltip_type_id);
	}
	return gala_tooltip_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 628 "Tooltip.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 632 "Tooltip.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 636 "Tooltip.c"
}

