/* WindowOverview.c generated by valac 0.56.14, the Vala compiler
 * generated from WindowOverview.vala, do not modify */

/*
 * Copyright 2012 Tom Beckmann
 * Copyright 2012 Rico Tzschichholz
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <clutter/clutter.h>
#include "gala.h"
#include <glib-object.h>
#include <glib.h>
#include <meta/workspace.h>
#include <stdlib.h>
#include <string.h>
#include <meta/meta-workspace-manager.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>
#include <meta/keybindings.h>
#include <mtk/mtk.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>

#define GALA_WINDOW_OVERVIEW_BORDER 10
#define GALA_WINDOW_OVERVIEW_TOP_GAP 30
#define GALA_WINDOW_OVERVIEW_BOTTOM_GAP 100
#define GALA_MULTITASKING_VIEW_ANIMATION_DURATION 250
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_OVERVIEW (gala_window_overview_get_type ())
#define GALA_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview))
#define GALA_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))
#define GALA_IS_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_IS_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_WINDOW_OVERVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))

typedef struct _GalaWindowOverview GalaWindowOverview;
typedef struct _GalaWindowOverviewClass GalaWindowOverviewClass;
typedef struct _GalaWindowOverviewPrivate GalaWindowOverviewPrivate;
enum  {
	GALA_WINDOW_OVERVIEW_0_PROPERTY,
	GALA_WINDOW_OVERVIEW_WM_PROPERTY,
	GALA_WINDOW_OVERVIEW_NUM_PROPERTIES
};
static GParamSpec* gala_window_overview_properties[GALA_WINDOW_OVERVIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GALA_TYPE_WINDOW_CLONE_CONTAINER (gala_window_clone_container_get_type ())
#define GALA_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer))
#define GALA_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))
#define GALA_IS_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_IS_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_WINDOW_CLONE_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))

typedef struct _GalaWindowCloneContainer GalaWindowCloneContainer;
typedef struct _GalaWindowCloneContainerClass GalaWindowCloneContainerClass;

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;
typedef struct _Block71Data Block71Data;

struct _GalaWindowOverview {
	ClutterActor parent_instance;
	GalaWindowOverviewPrivate * priv;
};

struct _GalaWindowOverviewClass {
	ClutterActorClass parent_class;
};

struct _GalaWindowOverviewPrivate {
	GalaWindowManager* _wm;
	GalaModalProxy* modal_proxy;
	GList* workspaces;
};

struct _Block71Data {
	int _ref_count_;
	GalaWindowOverview* self;
	MetaWindow* window;
};

static gint GalaWindowOverview_private_offset;
static gpointer gala_window_overview_parent_class = NULL;
static GalaActivatableComponentIface * gala_window_overview_gala_activatable_component_parent_iface = NULL;

VALA_EXTERN GType gala_window_overview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowOverview, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN GalaWindowOverview* gala_window_overview_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowOverview* gala_window_overview_construct (GType object_type,
                                                    GalaWindowManager* wm);
static gboolean gala_window_overview_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static void gala_window_overview_real_key_focus_out (ClutterActor* base);
static gboolean gala_window_overview_real_button_release_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_window_overview_real_is_opened (GalaActivatableComponent* base);
static void gala_window_overview_real_open (GalaActivatableComponent* base,
                                     GHashTable* hints);
VALA_EXTERN GalaWindowManager* gala_window_overview_get_wm (GalaWindowOverview* self);
static void gala_window_overview_add_window (GalaWindowOverview* self,
                                      MetaWindow* window);
static void _gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self);
static void gala_window_overview_remove_window (GalaWindowOverview* self,
                                         MetaWindow* window);
static void _gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                        MetaWindow* object,
                                                                        gpointer self);
static void gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                               gint num,
                                               MetaWindow* window);
static void _gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                                 gint object,
                                                                                 MetaWindow* p0,
                                                                                 gpointer self);
static gboolean gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                                 MetaKeyBinding* binding);
static gboolean _gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                         gpointer self);
VALA_EXTERN GType gala_window_clone_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowCloneContainer, g_object_unref)
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_new (GalaWindowManager* wm,
                                                           GalaGestureTracker* gesture_tracker,
                                                           gfloat scale,
                                                           gboolean overview_mode);
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_construct (GType object_type,
                                                                 GalaWindowManager* wm,
                                                                 GalaGestureTracker* gesture_tracker,
                                                                 gfloat scale,
                                                                 gboolean overview_mode);
VALA_EXTERN void gala_window_clone_container_set_padding_top (GalaWindowCloneContainer* self,
                                                  gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_left (GalaWindowCloneContainer* self,
                                                   gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_right (GalaWindowCloneContainer* self,
                                                    gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_bottom (GalaWindowCloneContainer* self,
                                                     gint value);
static void gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                          MetaWindow* window);
static void _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                       MetaWindow* window,
                                                                                       gpointer self);
VALA_EXTERN void gala_window_clone_container_add_window (GalaWindowCloneContainer* self,
                                             MetaWindow* window);
VALA_EXTERN void gala_window_clone_container_open (GalaWindowCloneContainer* self,
                                       MetaWindow* selected_window,
                                       gboolean with_gesture,
                                       gboolean is_cancel_animation);
static void gala_window_overview_restack_windows (GalaWindowOverview* self);
VALA_EXTERN void gala_window_clone_container_restack_windows (GalaWindowCloneContainer* self);
VALA_EXTERN void gala_window_clone_container_remove_window (GalaWindowCloneContainer* self,
                                                MetaWindow* window);
static Block71Data* block71_data_ref (Block71Data* _data71_);
static void block71_data_unref (void * _userdata_);
static gboolean ___lambda130_ (Block71Data* _data71_);
static gboolean ____lambda130__gsource_func (gpointer self);
static void gala_window_overview_real_close (GalaActivatableComponent* base,
                                      GHashTable* hints);
VALA_EXTERN void gala_window_clone_container_close (GalaWindowCloneContainer* self,
                                        gboolean with_gesture,
                                        gboolean is_cancel_animation);
static gboolean __lambda129_ (GalaWindowOverview* self);
static void gala_window_overview_cleanup (GalaWindowOverview* self);
static gboolean ___lambda129__gsource_func (gpointer self);
static void gala_window_overview_set_wm (GalaWindowOverview* self,
                                  GalaWindowManager* value);
static GObject * gala_window_overview_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void gala_window_overview_finalize (GObject * obj);
static GType gala_window_overview_get_type_once (void);
static void _vala_gala_window_overview_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_overview_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_window_overview_get_instance_private (GalaWindowOverview* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowOverview_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 18 "../src/Widgets/WindowOverview.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 228 "WindowOverview.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 18 "../src/Widgets/WindowOverview.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 236 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaWindowOverview * self = NULL;
#line 20 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 21 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) g_object_new (object_type, "wm", wm, NULL);
#line 20 "../src/Widgets/WindowOverview.vala"
	return self;
#line 250 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_new (GalaWindowManager* wm)
{
#line 20 "../src/Widgets/WindowOverview.vala"
	return gala_window_overview_construct (GALA_TYPE_WINDOW_OVERVIEW, wm);
#line 258 "WindowOverview.c"
}

static gboolean
gala_window_overview_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowOverview * self;
	gboolean result;
#line 30 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 30 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 34 "../src/Widgets/WindowOverview.vala"
	if (clutter_event_get_key_symbol (event) == CLUTTER_KEY_Escape) {
#line 35 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 37 "../src/Widgets/WindowOverview.vala"
		result = CLUTTER_EVENT_STOP;
#line 37 "../src/Widgets/WindowOverview.vala"
		return result;
#line 279 "WindowOverview.c"
	}
#line 40 "../src/Widgets/WindowOverview.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 40 "../src/Widgets/WindowOverview.vala"
	return result;
#line 285 "WindowOverview.c"
}

static void
gala_window_overview_real_key_focus_out (ClutterActor* base)
{
	GalaWindowOverview * self;
	ClutterStage* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
#line 43 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 44 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_stage ((ClutterActor*) self);
#line 44 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = clutter_stage_get_key_focus (_tmp0_);
#line 44 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = _tmp1_;
#line 44 "../src/Widgets/WindowOverview.vala"
	if (!clutter_actor_contains ((ClutterActor*) self, _tmp2_)) {
#line 45 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 307 "WindowOverview.c"
	}
}

static gboolean
gala_window_overview_real_button_release_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaWindowOverview * self;
	gboolean result;
#line 50 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 50 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 54 "../src/Widgets/WindowOverview.vala"
	if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 55 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 325 "WindowOverview.c"
	}
#line 58 "../src/Widgets/WindowOverview.vala"
	result = CLUTTER_EVENT_STOP;
#line 58 "../src/Widgets/WindowOverview.vala"
	return result;
#line 331 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
gala_window_overview_real_is_opened (GalaActivatableComponent* base)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 64 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 65 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 65 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/Widgets/WindowOverview.vala"
	result = _tmp1_;
#line 65 "../src/Widgets/WindowOverview.vala"
	return result;
#line 354 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 75 "../src/Widgets/WindowOverview.vala"
	return self ? g_object_ref (self) : NULL;
#line 365 "WindowOverview.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5252 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5252 "glib-2.0.vapi"
	return result;
#line 376 "WindowOverview.c"
}

static void
_gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                              MetaWindow* object,
                                                              gpointer self)
{
#line 110 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_add_window ((GalaWindowOverview*) self, object);
#line 386 "WindowOverview.c"
}

static void
_gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self)
{
#line 111 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_remove_window ((GalaWindowOverview*) self, object);
#line 396 "WindowOverview.c"
}

static void
_gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                            gint object,
                                                                            MetaWindow* p0,
                                                                            gpointer self)
{
#line 114 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_window_left_monitor ((GalaWindowOverview*) self, object, p0);
#line 407 "WindowOverview.c"
}

static gboolean
_gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                gpointer self)
{
	gboolean result;
	result = gala_window_overview_keybinding_filter ((GalaWindowOverview*) self, binding);
#line 119 "../src/Widgets/WindowOverview.vala"
	return result;
#line 418 "WindowOverview.c"
}

static void
_gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                  MetaWindow* window,
                                                                                  gpointer self)
{
#line 135 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_thumb_selected ((GalaWindowOverview*) self, window);
#line 428 "WindowOverview.c"
}

static void
gala_window_overview_real_open (GalaActivatableComponent* base,
                                GHashTable* hints)
{
	GalaWindowOverview * self;
	MetaWorkspaceManager* manager = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	GList* _tmp4_;
	GList* windows = NULL;
	GList* _tmp7_;
	GList* _tmp39_;
	GList* _tmp40_;
	GalaWindowManager* _tmp44_;
	MetaDisplay* _tmp45_;
	GalaWindowManager* _tmp46_;
	GalaModalProxy* _tmp47_;
	GalaModalProxy* _tmp48_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp49_;
	MetaDisplay* _tmp50_;
	GList* _tmp67_;
#line 71 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 72 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 72 "../src/Widgets/WindowOverview.vala"
	self->priv->workspaces = NULL;
#line 73 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 73 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 73 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 73 "../src/Widgets/WindowOverview.vala"
	manager = _tmp2_;
#line 74 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = manager;
#line 74 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_workspace_manager_get_workspaces (_tmp3_);
#line 473 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 74 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp4_;
#line 74 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 481 "WindowOverview.c"
			MetaWorkspace* workspace = NULL;
#line 74 "../src/Widgets/WindowOverview.vala"
			workspace = (MetaWorkspace*) workspace_it->data;
#line 485 "WindowOverview.c"
			{
				MetaWorkspace* _tmp5_;
				MetaWorkspace* _tmp6_;
#line 75 "../src/Widgets/WindowOverview.vala"
				_tmp5_ = workspace;
#line 75 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = _g_object_ref0 (_tmp5_);
#line 75 "../src/Widgets/WindowOverview.vala"
				self->priv->workspaces = g_list_append (self->priv->workspaces, _tmp6_);
#line 495 "WindowOverview.c"
			}
		}
	}
#line 78 "../src/Widgets/WindowOverview.vala"
	windows = NULL;
#line 79 "../src/Widgets/WindowOverview.vala"
	_tmp7_ = self->priv->workspaces;
#line 503 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 79 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp7_;
#line 79 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 511 "WindowOverview.c"
			MetaWorkspace* _tmp8_;
			MetaWorkspace* workspace = NULL;
#line 79 "../src/Widgets/WindowOverview.vala"
			_tmp8_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 79 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp8_;
#line 518 "WindowOverview.c"
			{
				MetaWorkspace* _tmp9_;
				GList* _tmp10_;
#line 80 "../src/Widgets/WindowOverview.vala"
				_tmp9_ = workspace;
#line 80 "../src/Widgets/WindowOverview.vala"
				_tmp10_ = meta_workspace_list_windows (_tmp9_);
#line 526 "WindowOverview.c"
				{
					GList* window_collection = NULL;
					GList* window_it = NULL;
#line 80 "../src/Widgets/WindowOverview.vala"
					window_collection = _tmp10_;
#line 80 "../src/Widgets/WindowOverview.vala"
					for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 534 "WindowOverview.c"
						MetaWindow* window = NULL;
#line 80 "../src/Widgets/WindowOverview.vala"
						window = (MetaWindow*) window_it->data;
#line 538 "WindowOverview.c"
						{
							gboolean _tmp11_ = FALSE;
							MetaWindow* _tmp12_;
							MetaWindowType _tmp13_;
							MetaWindowType _tmp14_;
							gboolean _tmp18_ = FALSE;
							gboolean _tmp19_ = FALSE;
							MetaWindow* _tmp20_;
							MetaWindowType _tmp21_;
							MetaWindowType _tmp22_;
							gboolean _tmp30_ = FALSE;
							MetaWindow* _tmp31_;
							gboolean _tmp32_;
							gboolean _tmp33_;
							MetaWindow* _tmp37_;
							MetaWindow* _tmp38_;
#line 81 "../src/Widgets/WindowOverview.vala"
							_tmp12_ = window;
#line 81 "../src/Widgets/WindowOverview.vala"
							_tmp13_ = meta_window_get_window_type (_tmp12_);
#line 81 "../src/Widgets/WindowOverview.vala"
							_tmp14_ = _tmp13_;
#line 81 "../src/Widgets/WindowOverview.vala"
							if (_tmp14_ == META_WINDOW_DOCK) {
#line 81 "../src/Widgets/WindowOverview.vala"
								_tmp11_ = TRUE;
#line 565 "WindowOverview.c"
							} else {
								MetaWindow* _tmp15_;
								MetaWindowType _tmp16_;
								MetaWindowType _tmp17_;
#line 82 "../src/Widgets/WindowOverview.vala"
								_tmp15_ = window;
#line 82 "../src/Widgets/WindowOverview.vala"
								_tmp16_ = meta_window_get_window_type (_tmp15_);
#line 82 "../src/Widgets/WindowOverview.vala"
								_tmp17_ = _tmp16_;
#line 82 "../src/Widgets/WindowOverview.vala"
								_tmp11_ = _tmp17_ == META_WINDOW_NOTIFICATION;
#line 578 "WindowOverview.c"
							}
#line 81 "../src/Widgets/WindowOverview.vala"
							if (_tmp11_) {
#line 83 "../src/Widgets/WindowOverview.vala"
								continue;
#line 584 "WindowOverview.c"
							}
#line 86 "../src/Widgets/WindowOverview.vala"
							_tmp20_ = window;
#line 86 "../src/Widgets/WindowOverview.vala"
							_tmp21_ = meta_window_get_window_type (_tmp20_);
#line 86 "../src/Widgets/WindowOverview.vala"
							_tmp22_ = _tmp21_;
#line 86 "../src/Widgets/WindowOverview.vala"
							if (_tmp22_ != META_WINDOW_NORMAL) {
#line 594 "WindowOverview.c"
								MetaWindow* _tmp23_;
								MetaWindowType _tmp24_;
								MetaWindowType _tmp25_;
#line 87 "../src/Widgets/WindowOverview.vala"
								_tmp23_ = window;
#line 87 "../src/Widgets/WindowOverview.vala"
								_tmp24_ = meta_window_get_window_type (_tmp23_);
#line 87 "../src/Widgets/WindowOverview.vala"
								_tmp25_ = _tmp24_;
#line 87 "../src/Widgets/WindowOverview.vala"
								_tmp19_ = _tmp25_ != META_WINDOW_DIALOG;
#line 606 "WindowOverview.c"
							} else {
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp19_ = FALSE;
#line 610 "WindowOverview.c"
							}
#line 86 "../src/Widgets/WindowOverview.vala"
							if (_tmp19_) {
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp18_ = TRUE;
#line 616 "WindowOverview.c"
							} else {
								MetaWindow* _tmp26_;
#line 88 "../src/Widgets/WindowOverview.vala"
								_tmp26_ = window;
#line 88 "../src/Widgets/WindowOverview.vala"
								_tmp18_ = meta_window_is_attached_dialog (_tmp26_);
#line 623 "WindowOverview.c"
							}
#line 86 "../src/Widgets/WindowOverview.vala"
							if (_tmp18_) {
#line 627 "WindowOverview.c"
								MetaWindowActor* actor = NULL;
								MetaWindow* _tmp27_;
								GObject* _tmp28_;
								MetaWindowActor* _tmp29_;
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp27_ = window;
#line 89 "../src/Widgets/WindowOverview.vala"
								_tmp28_ = meta_window_get_compositor_private (_tmp27_);
#line 89 "../src/Widgets/WindowOverview.vala"
								actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, meta_window_actor_get_type (), MetaWindowActor);
#line 90 "../src/Widgets/WindowOverview.vala"
								_tmp29_ = actor;
#line 90 "../src/Widgets/WindowOverview.vala"
								clutter_actor_hide ((ClutterActor*) _tmp29_);
#line 92 "../src/Widgets/WindowOverview.vala"
								continue;
#line 644 "WindowOverview.c"
							}
#line 97 "../src/Widgets/WindowOverview.vala"
							_tmp31_ = window;
#line 97 "../src/Widgets/WindowOverview.vala"
							g_object_get (_tmp31_, "on-all-workspaces", &_tmp32_, NULL);
#line 97 "../src/Widgets/WindowOverview.vala"
							_tmp33_ = _tmp32_;
#line 97 "../src/Widgets/WindowOverview.vala"
							if (_tmp33_) {
#line 654 "WindowOverview.c"
								MetaWindow* _tmp34_;
								MetaWorkspace* _tmp35_;
								MetaWorkspace* _tmp36_;
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp34_ = window;
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp35_ = meta_window_get_workspace (_tmp34_);
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp36_ = workspace;
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp30_ = _tmp35_ != _tmp36_;
#line 666 "WindowOverview.c"
							} else {
#line 97 "../src/Widgets/WindowOverview.vala"
								_tmp30_ = FALSE;
#line 670 "WindowOverview.c"
							}
#line 97 "../src/Widgets/WindowOverview.vala"
							if (_tmp30_) {
#line 98 "../src/Widgets/WindowOverview.vala"
								continue;
#line 676 "WindowOverview.c"
							}
#line 101 "../src/Widgets/WindowOverview.vala"
							_tmp37_ = window;
#line 101 "../src/Widgets/WindowOverview.vala"
							_tmp38_ = _g_object_ref0 (_tmp37_);
#line 101 "../src/Widgets/WindowOverview.vala"
							windows = g_list_append (windows, _tmp38_);
#line 684 "WindowOverview.c"
						}
					}
#line 80 "../src/Widgets/WindowOverview.vala"
					(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 689 "WindowOverview.c"
				}
#line 79 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 693 "WindowOverview.c"
			}
		}
	}
#line 105 "../src/Widgets/WindowOverview.vala"
	_tmp39_ = windows;
#line 105 "../src/Widgets/WindowOverview.vala"
	if (vala_g_list_is_empty (_tmp39_)) {
#line 106 "../src/Widgets/WindowOverview.vala"
		(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 106 "../src/Widgets/WindowOverview.vala"
		return;
#line 705 "WindowOverview.c"
	}
#line 109 "../src/Widgets/WindowOverview.vala"
	_tmp40_ = self->priv->workspaces;
#line 709 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 109 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp40_;
#line 109 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 717 "WindowOverview.c"
			MetaWorkspace* _tmp41_;
			MetaWorkspace* workspace = NULL;
#line 109 "../src/Widgets/WindowOverview.vala"
			_tmp41_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 109 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp41_;
#line 724 "WindowOverview.c"
			{
				MetaWorkspace* _tmp42_;
				MetaWorkspace* _tmp43_;
#line 110 "../src/Widgets/WindowOverview.vala"
				_tmp42_ = workspace;
#line 110 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp42_, "window-added", (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self, 0);
#line 111 "../src/Widgets/WindowOverview.vala"
				_tmp43_ = workspace;
#line 111 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp43_, "window-removed", (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self, 0);
#line 109 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 738 "WindowOverview.c"
			}
		}
	}
#line 114 "../src/Widgets/WindowOverview.vala"
	_tmp44_ = self->priv->_wm;
#line 114 "../src/Widgets/WindowOverview.vala"
	_tmp45_ = meta_plugin_get_display ((MetaPlugin*) _tmp44_);
#line 114 "../src/Widgets/WindowOverview.vala"
	g_signal_connect_object (_tmp45_, "window-left-monitor", (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self, 0);
#line 116 "../src/Widgets/WindowOverview.vala"
	clutter_actor_grab_key_focus ((ClutterActor*) self);
#line 118 "../src/Widgets/WindowOverview.vala"
	_tmp46_ = self->priv->_wm;
#line 118 "../src/Widgets/WindowOverview.vala"
	_tmp47_ = gala_window_manager_push_modal (_tmp46_, (ClutterActor*) self);
#line 118 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 118 "../src/Widgets/WindowOverview.vala"
	self->priv->modal_proxy = _tmp47_;
#line 119 "../src/Widgets/WindowOverview.vala"
	_tmp48_ = self->priv->modal_proxy;
#line 119 "../src/Widgets/WindowOverview.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp48_, _gala_window_overview_keybinding_filter_gala_keybinding_filter, self);
#line 121 "../src/Widgets/WindowOverview.vala"
	_tmp49_ = self->priv->_wm;
#line 121 "../src/Widgets/WindowOverview.vala"
	_tmp50_ = meta_plugin_get_display ((MetaPlugin*) _tmp49_);
#line 121 "../src/Widgets/WindowOverview.vala"
	display = _tmp50_;
#line 768 "WindowOverview.c"
	{
		gint i = 0;
#line 123 "../src/Widgets/WindowOverview.vala"
		i = 0;
#line 773 "WindowOverview.c"
		{
			gboolean _tmp51_ = FALSE;
#line 123 "../src/Widgets/WindowOverview.vala"
			_tmp51_ = TRUE;
#line 123 "../src/Widgets/WindowOverview.vala"
			while (TRUE) {
#line 780 "WindowOverview.c"
				MetaDisplay* _tmp53_;
				MtkRectangle geometry = {0};
				MetaDisplay* _tmp54_;
				MtkRectangle _tmp55_ = {0};
				gfloat scale = 0.0F;
				MetaDisplay* _tmp56_;
				GalaWindowCloneContainer* container = NULL;
				GalaWindowManager* _tmp57_;
				GalaWindowCloneContainer* _tmp58_ = NULL;
				GalaWindowCloneContainer* _tmp59_;
				MtkRectangle _tmp60_;
				MtkRectangle _tmp61_;
				GalaWindowCloneContainer* _tmp62_;
				MtkRectangle _tmp63_;
				MtkRectangle _tmp64_;
				GalaWindowCloneContainer* _tmp65_;
				GalaWindowCloneContainer* _tmp66_;
#line 123 "../src/Widgets/WindowOverview.vala"
				if (!_tmp51_) {
#line 800 "WindowOverview.c"
					gint _tmp52_;
#line 123 "../src/Widgets/WindowOverview.vala"
					_tmp52_ = i;
#line 123 "../src/Widgets/WindowOverview.vala"
					i = _tmp52_ + 1;
#line 806 "WindowOverview.c"
				}
#line 123 "../src/Widgets/WindowOverview.vala"
				_tmp51_ = FALSE;
#line 123 "../src/Widgets/WindowOverview.vala"
				_tmp53_ = display;
#line 123 "../src/Widgets/WindowOverview.vala"
				if (!(i < meta_display_get_n_monitors (_tmp53_))) {
#line 123 "../src/Widgets/WindowOverview.vala"
					break;
#line 816 "WindowOverview.c"
				}
#line 124 "../src/Widgets/WindowOverview.vala"
				_tmp54_ = display;
#line 124 "../src/Widgets/WindowOverview.vala"
				meta_display_get_monitor_geometry (_tmp54_, i, &_tmp55_);
#line 124 "../src/Widgets/WindowOverview.vala"
				geometry = _tmp55_;
#line 125 "../src/Widgets/WindowOverview.vala"
				_tmp56_ = display;
#line 125 "../src/Widgets/WindowOverview.vala"
				scale = meta_display_get_monitor_scale (_tmp56_, i);
#line 127 "../src/Widgets/WindowOverview.vala"
				_tmp57_ = self->priv->_wm;
#line 127 "../src/Widgets/WindowOverview.vala"
				_tmp58_ = gala_window_clone_container_new (_tmp57_, NULL, scale, TRUE);
#line 127 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_top (_tmp58_, GALA_WINDOW_OVERVIEW_TOP_GAP);
#line 127 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_left (_tmp58_, GALA_WINDOW_OVERVIEW_BORDER);
#line 127 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_right (_tmp58_, GALA_WINDOW_OVERVIEW_BORDER);
#line 127 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_bottom (_tmp58_, GALA_WINDOW_OVERVIEW_BOTTOM_GAP);
#line 127 "../src/Widgets/WindowOverview.vala"
				g_object_ref_sink (_tmp58_);
#line 127 "../src/Widgets/WindowOverview.vala"
				container = _tmp58_;
#line 133 "../src/Widgets/WindowOverview.vala"
				_tmp59_ = container;
#line 133 "../src/Widgets/WindowOverview.vala"
				_tmp60_ = geometry;
#line 133 "../src/Widgets/WindowOverview.vala"
				_tmp61_ = geometry;
#line 133 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_position ((ClutterActor*) _tmp59_, (gfloat) _tmp60_.x, (gfloat) _tmp61_.y);
#line 134 "../src/Widgets/WindowOverview.vala"
				_tmp62_ = container;
#line 134 "../src/Widgets/WindowOverview.vala"
				_tmp63_ = geometry;
#line 134 "../src/Widgets/WindowOverview.vala"
				_tmp64_ = geometry;
#line 134 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_size ((ClutterActor*) _tmp62_, (gfloat) _tmp63_.width, (gfloat) _tmp64_.height);
#line 135 "../src/Widgets/WindowOverview.vala"
				_tmp65_ = container;
#line 135 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp65_, "window-selected", (GCallback) _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected, self, 0);
#line 137 "../src/Widgets/WindowOverview.vala"
				_tmp66_ = container;
#line 137 "../src/Widgets/WindowOverview.vala"
				clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp66_);
#line 123 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (container);
#line 870 "WindowOverview.c"
			}
		}
	}
#line 140 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 142 "../src/Widgets/WindowOverview.vala"
	_tmp67_ = windows;
#line 878 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 142 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp67_;
#line 142 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 886 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 142 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 890 "WindowOverview.c"
			{
				MetaWindowActor* actor = NULL;
				MetaWindow* _tmp68_;
				GObject* _tmp69_;
				MetaWindowActor* _tmp70_;
				GalaWindowCloneContainer* container = NULL;
				MetaWindow* _tmp71_;
				ClutterActor* _tmp72_;
				GalaWindowCloneContainer* _tmp73_;
				GalaWindowCloneContainer* _tmp74_;
				MetaWindow* _tmp75_;
				GalaWindowCloneContainer* _tmp76_;
#line 143 "../src/Widgets/WindowOverview.vala"
				_tmp68_ = window;
#line 143 "../src/Widgets/WindowOverview.vala"
				_tmp69_ = meta_window_get_compositor_private (_tmp68_);
#line 143 "../src/Widgets/WindowOverview.vala"
				actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, meta_window_actor_get_type (), MetaWindowActor);
#line 144 "../src/Widgets/WindowOverview.vala"
				_tmp70_ = actor;
#line 144 "../src/Widgets/WindowOverview.vala"
				clutter_actor_hide ((ClutterActor*) _tmp70_);
#line 146 "../src/Widgets/WindowOverview.vala"
				_tmp71_ = window;
#line 146 "../src/Widgets/WindowOverview.vala"
				_tmp72_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (_tmp71_));
#line 146 "../src/Widgets/WindowOverview.vala"
				container = G_TYPE_CHECK_INSTANCE_CAST (_tmp72_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 147 "../src/Widgets/WindowOverview.vala"
				_tmp73_ = container;
#line 147 "../src/Widgets/WindowOverview.vala"
				if (_tmp73_ == NULL) {
#line 148 "../src/Widgets/WindowOverview.vala"
					continue;
#line 925 "WindowOverview.c"
				}
#line 151 "../src/Widgets/WindowOverview.vala"
				_tmp74_ = container;
#line 151 "../src/Widgets/WindowOverview.vala"
				_tmp75_ = window;
#line 151 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_add_window (_tmp74_, _tmp75_);
#line 152 "../src/Widgets/WindowOverview.vala"
				_tmp76_ = container;
#line 152 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_open (_tmp76_, NULL, FALSE, FALSE);
#line 937 "WindowOverview.c"
			}
		}
	}
#line 71 "../src/Widgets/WindowOverview.vala"
	(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 943 "WindowOverview.c"
}

static gboolean
gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                        MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 167 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label0 = 0;
#line 167 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label1 = 0;
#line 167 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label2 = 0;
#line 961 "WindowOverview.c"
	gboolean result;
#line 156 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 157 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 157 "../src/Widgets/WindowOverview.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 159 "../src/Widgets/WindowOverview.vala"
	switch (action) {
#line 159 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 159 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 977 "WindowOverview.c"
		{
#line 162 "../src/Widgets/WindowOverview.vala"
			result = FALSE;
#line 162 "../src/Widgets/WindowOverview.vala"
			return result;
#line 983 "WindowOverview.c"
		}
		default:
		{
#line 164 "../src/Widgets/WindowOverview.vala"
			break;
#line 989 "WindowOverview.c"
		}
	}
#line 167 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 167 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = _tmp1_;
#line 167 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 167 "../src/Widgets/WindowOverview.vala"
	if (((_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("expose-all-windows")))) || (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("zoom-in"))))) || (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("zoom-out"))))) {
#line 167 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1002 "WindowOverview.c"
			default:
			{
#line 171 "../src/Widgets/WindowOverview.vala"
				result = FALSE;
#line 171 "../src/Widgets/WindowOverview.vala"
				return result;
#line 1009 "WindowOverview.c"
			}
		}
	} else {
#line 167 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1015 "WindowOverview.c"
			default:
			{
#line 173 "../src/Widgets/WindowOverview.vala"
				break;
#line 1020 "WindowOverview.c"
			}
		}
	}
#line 176 "../src/Widgets/WindowOverview.vala"
	result = TRUE;
#line 176 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1028 "WindowOverview.c"
}

static void
gala_window_overview_restack_windows (GalaWindowOverview* self)
{
	GList* _tmp0_;
#line 179 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_children ((ClutterActor*) self);
#line 1039 "WindowOverview.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 180 "../src/Widgets/WindowOverview.vala"
		child_collection = _tmp0_;
#line 180 "../src/Widgets/WindowOverview.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1047 "WindowOverview.c"
			ClutterActor* child = NULL;
#line 180 "../src/Widgets/WindowOverview.vala"
			child = (ClutterActor*) child_it->data;
#line 1051 "WindowOverview.c"
			{
				ClutterActor* _tmp1_;
#line 181 "../src/Widgets/WindowOverview.vala"
				_tmp1_ = child;
#line 181 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_restack_windows (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer));
#line 1058 "WindowOverview.c"
			}
		}
#line 180 "../src/Widgets/WindowOverview.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1063 "WindowOverview.c"
	}
}

static void
gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                          gint num,
                                          MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GList* _tmp2_;
#line 185 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 185 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 186 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, num);
#line 186 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 187 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 187 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 188 "../src/Widgets/WindowOverview.vala"
		return;
#line 1090 "WindowOverview.c"
	}
#line 192 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1094 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 192 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 192 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1102 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 192 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 192 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1109 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
#line 193 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 193 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp4_)) {
#line 1116 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp5_;
#line 194 "../src/Widgets/WindowOverview.vala"
					_tmp5_ = container;
#line 194 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_remove_window (_tmp5_, window);
#line 195 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 195 "../src/Widgets/WindowOverview.vala"
					break;
#line 1126 "WindowOverview.c"
				}
#line 192 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1130 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_add_window (GalaWindowOverview* self,
                                 MetaWindow* window)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWindowType _tmp3_;
	MetaWindowType _tmp4_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	MetaWindowType _tmp9_;
	MetaWindowType _tmp10_;
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp15_;
	GalaWindowCloneContainer* _tmp16_;
	GList* _tmp17_;
#line 200 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 201 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 201 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 201 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 202 "../src/Widgets/WindowOverview.vala"
		return;
#line 1165 "WindowOverview.c"
	}
#line 204 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_window_get_window_type (window);
#line 204 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = _tmp3_;
#line 204 "../src/Widgets/WindowOverview.vala"
	if (_tmp4_ == META_WINDOW_DOCK) {
#line 204 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = TRUE;
#line 1175 "WindowOverview.c"
	} else {
		MetaWindowType _tmp5_;
		MetaWindowType _tmp6_;
#line 205 "../src/Widgets/WindowOverview.vala"
		_tmp5_ = meta_window_get_window_type (window);
#line 205 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = _tmp5_;
#line 205 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = _tmp6_ == META_WINDOW_NOTIFICATION;
#line 1185 "WindowOverview.c"
	}
#line 204 "../src/Widgets/WindowOverview.vala"
	if (_tmp2_) {
#line 206 "../src/Widgets/WindowOverview.vala"
		return;
#line 1191 "WindowOverview.c"
	}
#line 208 "../src/Widgets/WindowOverview.vala"
	_tmp9_ = meta_window_get_window_type (window);
#line 208 "../src/Widgets/WindowOverview.vala"
	_tmp10_ = _tmp9_;
#line 208 "../src/Widgets/WindowOverview.vala"
	if (_tmp10_ != META_WINDOW_NORMAL) {
#line 1199 "WindowOverview.c"
		MetaWindowType _tmp11_;
		MetaWindowType _tmp12_;
#line 209 "../src/Widgets/WindowOverview.vala"
		_tmp11_ = meta_window_get_window_type (window);
#line 209 "../src/Widgets/WindowOverview.vala"
		_tmp12_ = _tmp11_;
#line 209 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = _tmp12_ != META_WINDOW_DIALOG;
#line 1208 "WindowOverview.c"
	} else {
#line 208 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = FALSE;
#line 1212 "WindowOverview.c"
	}
#line 208 "../src/Widgets/WindowOverview.vala"
	if (_tmp8_) {
#line 208 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = TRUE;
#line 1218 "WindowOverview.c"
	} else {
#line 210 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = meta_window_is_attached_dialog (window);
#line 1222 "WindowOverview.c"
	}
#line 208 "../src/Widgets/WindowOverview.vala"
	if (_tmp7_) {
#line 1226 "WindowOverview.c"
		MetaWindowActor* actor = NULL;
		GObject* _tmp13_;
		MetaWindowActor* _tmp14_;
#line 211 "../src/Widgets/WindowOverview.vala"
		_tmp13_ = meta_window_get_compositor_private (window);
#line 211 "../src/Widgets/WindowOverview.vala"
		actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, meta_window_actor_get_type (), MetaWindowActor);
#line 212 "../src/Widgets/WindowOverview.vala"
		_tmp14_ = actor;
#line 212 "../src/Widgets/WindowOverview.vala"
		clutter_actor_hide ((ClutterActor*) _tmp14_);
#line 214 "../src/Widgets/WindowOverview.vala"
		return;
#line 1240 "WindowOverview.c"
	}
#line 217 "../src/Widgets/WindowOverview.vala"
	_tmp15_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 217 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 218 "../src/Widgets/WindowOverview.vala"
	_tmp16_ = container;
#line 218 "../src/Widgets/WindowOverview.vala"
	if (_tmp16_ == NULL) {
#line 219 "../src/Widgets/WindowOverview.vala"
		return;
#line 1252 "WindowOverview.c"
	}
#line 223 "../src/Widgets/WindowOverview.vala"
	_tmp17_ = self->priv->workspaces;
#line 1256 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 223 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp17_;
#line 223 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1264 "WindowOverview.c"
			MetaWorkspace* _tmp18_;
			MetaWorkspace* workspace = NULL;
#line 223 "../src/Widgets/WindowOverview.vala"
			_tmp18_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 223 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp18_;
#line 1271 "WindowOverview.c"
			{
				MetaWorkspace* _tmp19_;
#line 224 "../src/Widgets/WindowOverview.vala"
				_tmp19_ = workspace;
#line 224 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp19_)) {
#line 1278 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp20_;
#line 225 "../src/Widgets/WindowOverview.vala"
					_tmp20_ = container;
#line 225 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_add_window (_tmp20_, window);
#line 226 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 226 "../src/Widgets/WindowOverview.vala"
					break;
#line 1288 "WindowOverview.c"
				}
#line 223 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1292 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_remove_window (GalaWindowOverview* self,
                                    MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GalaWindowCloneContainer* _tmp2_;
#line 231 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 232 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 232 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 233 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 233 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 234 "../src/Widgets/WindowOverview.vala"
		return;
#line 1320 "WindowOverview.c"
	}
#line 237 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = container;
#line 237 "../src/Widgets/WindowOverview.vala"
	gala_window_clone_container_remove_window (_tmp2_, window);
#line 1326 "WindowOverview.c"
}

static Block71Data*
block71_data_ref (Block71Data* _data71_)
{
#line 240 "../src/Widgets/WindowOverview.vala"
	g_atomic_int_inc (&_data71_->_ref_count_);
#line 240 "../src/Widgets/WindowOverview.vala"
	return _data71_;
#line 1336 "WindowOverview.c"
}

static void
block71_data_unref (void * _userdata_)
{
	Block71Data* _data71_;
	_data71_ = (Block71Data*) _userdata_;
#line 240 "../src/Widgets/WindowOverview.vala"
	if (g_atomic_int_dec_and_test (&_data71_->_ref_count_)) {
#line 1346 "WindowOverview.c"
		GalaWindowOverview* self;
#line 240 "../src/Widgets/WindowOverview.vala"
		self = _data71_->self;
#line 240 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (_data71_->window);
#line 240 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self);
#line 240 "../src/Widgets/WindowOverview.vala"
		g_slice_free (Block71Data, _data71_);
#line 1356 "WindowOverview.c"
	}
}

static gboolean
___lambda130_ (Block71Data* _data71_)
{
	GalaWindowOverview* self;
	MetaWorkspace* _tmp0_;
	MetaDisplay* _tmp1_;
	gboolean result;
#line 248 "../src/Widgets/WindowOverview.vala"
	self = _data71_->self;
#line 249 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_window_get_workspace (_data71_->window);
#line 249 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_display (_data71_->window);
#line 249 "../src/Widgets/WindowOverview.vala"
	meta_workspace_activate_with_focus (_tmp0_, _data71_->window, meta_display_get_current_time (_tmp1_));
#line 250 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 250 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1379 "WindowOverview.c"
}

static gboolean
____lambda130__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda130_ (self);
#line 248 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1389 "WindowOverview.c"
}

static void
gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                     MetaWindow* window)
{
	Block71Data* _data71_;
	MetaWindow* _tmp0_;
	MetaWorkspace* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
#line 240 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 240 "../src/Widgets/WindowOverview.vala"
	_data71_ = g_slice_new0 (Block71Data);
#line 240 "../src/Widgets/WindowOverview.vala"
	_data71_->_ref_count_ = 1;
#line 240 "../src/Widgets/WindowOverview.vala"
	_data71_->self = g_object_ref (self);
#line 240 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 240 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (_data71_->window);
#line 240 "../src/Widgets/WindowOverview.vala"
	_data71_->window = _tmp0_;
#line 241 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_workspace (_data71_->window);
#line 241 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 241 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 241 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 241 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 241 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == _tmp5_) {
#line 1431 "WindowOverview.c"
		MetaDisplay* _tmp6_;
#line 242 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = meta_window_get_display (_data71_->window);
#line 242 "../src/Widgets/WindowOverview.vala"
		meta_window_activate (_data71_->window, meta_display_get_current_time (_tmp6_));
#line 243 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 1439 "WindowOverview.c"
	} else {
#line 245 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 248 "../src/Widgets/WindowOverview.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ____lambda130__gsource_func, block71_data_ref (_data71_), block71_data_unref);
#line 1445 "WindowOverview.c"
	}
#line 240 "../src/Widgets/WindowOverview.vala"
	block71_data_unref (_data71_);
#line 240 "../src/Widgets/WindowOverview.vala"
	_data71_ = NULL;
#line 1451 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
__lambda129_ (GalaWindowOverview* self)
{
	gboolean result;
#line 276 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_cleanup (self);
#line 278 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 278 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1467 "WindowOverview.c"
}

static gboolean
___lambda129__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda129_ ((GalaWindowOverview*) self);
#line 275 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1477 "WindowOverview.c"
}

static void
gala_window_overview_real_close (GalaActivatableComponent* base,
                                 GHashTable* hints)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GList* _tmp2_;
	GalaWindowManager* _tmp8_;
	MetaDisplay* _tmp9_;
	guint _tmp10_;
	GList* _tmp11_;
#line 258 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 259 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 259 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 259 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 260 "../src/Widgets/WindowOverview.vala"
		return;
#line 1502 "WindowOverview.c"
	}
#line 263 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_restack_windows (self);
#line 265 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1508 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 265 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 265 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1516 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 265 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 265 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1523 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
				guint _tmp5_;
				MetaWorkspace* _tmp6_;
				guint _tmp7_;
#line 266 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 266 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp5_, NULL, FALSE);
#line 266 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self);
#line 267 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = workspace;
#line 267 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp7_, NULL, FALSE);
#line 267 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self);
#line 265 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1543 "WindowOverview.c"
			}
		}
	}
#line 269 "../src/Widgets/WindowOverview.vala"
	_tmp8_ = self->priv->_wm;
#line 269 "../src/Widgets/WindowOverview.vala"
	_tmp9_ = meta_plugin_get_display ((MetaPlugin*) _tmp8_);
#line 269 "../src/Widgets/WindowOverview.vala"
	g_signal_parse_name ("window-left-monitor", meta_display_get_type (), &_tmp10_, NULL, FALSE);
#line 269 "../src/Widgets/WindowOverview.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self);
#line 271 "../src/Widgets/WindowOverview.vala"
	_tmp11_ = clutter_actor_get_children ((ClutterActor*) self);
#line 1557 "WindowOverview.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 271 "../src/Widgets/WindowOverview.vala"
		child_collection = _tmp11_;
#line 271 "../src/Widgets/WindowOverview.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1565 "WindowOverview.c"
			ClutterActor* child = NULL;
#line 271 "../src/Widgets/WindowOverview.vala"
			child = (ClutterActor*) child_it->data;
#line 1569 "WindowOverview.c"
			{
				ClutterActor* _tmp12_;
#line 272 "../src/Widgets/WindowOverview.vala"
				_tmp12_ = child;
#line 272 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_close (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer), FALSE, FALSE);
#line 1576 "WindowOverview.c"
			}
		}
#line 271 "../src/Widgets/WindowOverview.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1581 "WindowOverview.c"
	}
#line 275 "../src/Widgets/WindowOverview.vala"
	clutter_threads_add_timeout ((guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ___lambda129__gsource_func, self);
#line 1585 "WindowOverview.c"
}

static void
gala_window_overview_cleanup (GalaWindowOverview* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	GList* _tmp6_;
#line 282 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 285 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 285 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = self->priv->modal_proxy;
#line 285 "../src/Widgets/WindowOverview.vala"
	gala_window_manager_pop_modal (_tmp0_, _tmp1_);
#line 287 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 287 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 287 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 287 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 287 "../src/Widgets/WindowOverview.vala"
	_tmp6_ = meta_workspace_list_windows (_tmp5_);
#line 1618 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 287 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp6_;
#line 287 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1626 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 287 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 1630 "WindowOverview.c"
			{
				MetaWindow* _tmp7_;
#line 288 "../src/Widgets/WindowOverview.vala"
				_tmp7_ = window;
#line 288 "../src/Widgets/WindowOverview.vala"
				if (meta_window_showing_on_its_workspace (_tmp7_)) {
#line 1637 "WindowOverview.c"
					MetaWindow* _tmp8_;
					GObject* _tmp9_;
#line 289 "../src/Widgets/WindowOverview.vala"
					_tmp8_ = window;
#line 289 "../src/Widgets/WindowOverview.vala"
					_tmp9_ = meta_window_get_compositor_private (_tmp8_);
#line 289 "../src/Widgets/WindowOverview.vala"
					clutter_actor_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, clutter_actor_get_type (), ClutterActor));
#line 1646 "WindowOverview.c"
				}
			}
		}
#line 287 "../src/Widgets/WindowOverview.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1652 "WindowOverview.c"
	}
#line 293 "../src/Widgets/WindowOverview.vala"
	clutter_actor_destroy_all_children ((ClutterActor*) self);
#line 1656 "WindowOverview.c"
}

GalaWindowManager*
gala_window_overview_get_wm (GalaWindowOverview* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 13 "../src/Widgets/WindowOverview.vala"
	result = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1672 "WindowOverview.c"
}

static void
gala_window_overview_set_wm (GalaWindowOverview* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	old_value = gala_window_overview_get_wm (self);
#line 13 "../src/Widgets/WindowOverview.vala"
	if (old_value != value) {
#line 1686 "WindowOverview.c"
		GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 13 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self->priv->_wm);
#line 13 "../src/Widgets/WindowOverview.vala"
		self->priv->_wm = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY]);
#line 1696 "WindowOverview.c"
	}
}

static GObject *
gala_window_overview_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowOverview * self;
#line 24 "../src/Widgets/WindowOverview.vala"
	parent_class = G_OBJECT_CLASS (gala_window_overview_parent_class);
#line 24 "../src/Widgets/WindowOverview.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 24 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 25 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 26 "../src/Widgets/WindowOverview.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 24 "../src/Widgets/WindowOverview.vala"
	return obj;
#line 1720 "WindowOverview.c"
}

static void
gala_window_overview_class_init (GalaWindowOverviewClass * klass,
                                 gpointer klass_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Widgets/WindowOverview.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowOverview_private_offset);
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_key_press_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor*)) gala_window_overview_real_key_focus_out;
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->button_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_button_release_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_overview_get_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_overview_set_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_overview_constructor;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_overview_finalize;
#line 8 "../src/Widgets/WindowOverview.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_OVERVIEW_WM_PROPERTY, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1747 "WindowOverview.c"
}

static void
gala_window_overview_gala_activatable_component_interface_init (GalaActivatableComponentIface * iface,
                                                                gpointer iface_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_gala_activatable_component_parent_iface = g_type_interface_peek_parent (iface);
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->is_opened = (gboolean (*) (GalaActivatableComponent*)) gala_window_overview_real_is_opened;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->open = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_open;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->close = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_close;
#line 1762 "WindowOverview.c"
}

static void
gala_window_overview_instance_init (GalaWindowOverview * self,
                                    gpointer klass)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	self->priv = gala_window_overview_get_instance_private (self);
#line 1771 "WindowOverview.c"
}

static void
gala_window_overview_finalize (GObject * obj)
{
	GalaWindowOverview * self;
#line 8 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 13 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->_wm);
#line 15 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 18 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (gala_window_overview_parent_class)->finalize (obj);
#line 1788 "WindowOverview.c"
}

static GType
gala_window_overview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowOverviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_overview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowOverview), 0, (GInstanceInitFunc) gala_window_overview_instance_init, NULL };
	static const GInterfaceInfo gala_activatable_component_info = { (GInterfaceInitFunc) gala_window_overview_gala_activatable_component_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_window_overview_type_id;
	gala_window_overview_type_id = g_type_register_static (clutter_actor_get_type (), "GalaWindowOverview", &g_define_type_info, 0);
	g_type_add_interface_static (gala_window_overview_type_id, GALA_TYPE_ACTIVATABLE_COMPONENT, &gala_activatable_component_info);
	GalaWindowOverview_private_offset = g_type_add_instance_private (gala_window_overview_type_id, sizeof (GalaWindowOverviewPrivate));
	return gala_window_overview_type_id;
}

GType
gala_window_overview_get_type (void)
{
	static volatile gsize gala_window_overview_type_id__once = 0;
	if (g_once_init_enter (&gala_window_overview_type_id__once)) {
		GType gala_window_overview_type_id;
		gala_window_overview_type_id = gala_window_overview_get_type_once ();
		g_once_init_leave (&gala_window_overview_type_id__once, gala_window_overview_type_id);
	}
	return gala_window_overview_type_id__once;
}

static void
_vala_gala_window_overview_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		g_value_set_object (value, gala_window_overview_get_wm (self));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1831 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1837 "WindowOverview.c"
	}
}

static void
_vala_gala_window_overview_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		gala_window_overview_set_wm (self, g_value_get_object (value));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1857 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 1863 "WindowOverview.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 1878 "WindowOverview.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 1882 "WindowOverview.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 1886 "WindowOverview.c"
}

